EnableExplicit

CompilerIf #PB_Compiler_Debugger
  #TestIT = 3
  CompilerElse
  #TestIT = 0
  CompilerEndIf
#BASS_UseMidi = 1

#ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
#ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_WtoA = 1

;MessageRequester("1", "2")



CompilerIf #TestIT
  #Console = 1
  CompilerElse
  #Console = 0
  CompilerEndIf

; unicode with 2.4!!!  If VersionID > $20003
CompilerIf #BASS_UseMidi
  Import "kernel32.lib"
    GetFileAttributesW.i(*Filename)
    FindFirstFileW.i(*ptrDirEx, *xType1)
    lstrcpyW(*ptrDirEx, *xType1)
    lstrlenW(*lpString)
    lstrcmpiW(*lpString1, *lpString2)
    FindNextFileW(*xLong1, *xType1)
    GetModuleFileNameW(*Param1, *Mem, *Param2)
    GetModuleHandleW(*Param)
    GetSystemDirectoryW(*Mem, *Size)
    EndImport
  CompilerEndIf

XIncludeFile "ctSSLayer_Common_FullDLL.pb"
CompilerIf #BASS_UseMidi
  XIncludeFile "ctSSLayer_Common_LocalAllocStringWFromW.pb" ;- LocalAllocStringWFromW
  CompilerEndIf
XIncludeFile "ctSSLayer_Common_LocalAllocStringAFromA.pb" ;- LocalAllocStringWFromW
CompilerIf #BASS_UseMidi Or #ctSSLayer_CompiledFeature_GetDeviceNameW
  XIncludeFile "ctSSLayer_Common_LocalAllocStringWFromAnsiOrUTF8Mem.pb" ;- LocalAllocStringWFromAnsiOrUTF8Mem
  CompilerEndIf

CompilerIf #TestIT
  CompilerIf #Console
#ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
#ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_WtoA = 1
XIncludeFile "ctSSLayer_Common_FullDLL.pb"
CompilerEndIf
CompilerEndIf

; Copyright (C) 2002-2007 Jan Vorel
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; If you have any questions, suggestions or bug reports about this product,
; contact me: info@ctuser.net; Do not contact me about general B.A.S.I.C.
; language or A.P.I. issues
;
; Currently supporting 2.02 / 2.03



Declare.i ctSSLayer_PreInit(MainHWnd.i)

Prototype.d ProtoBASS_ChannelBytes2Seconds24(Handle.i, Pos.q)
Prototype.f ProtoBASS_ChannelBytes2Seconds23(Handle.i, Pos.q)
Prototype.q ProtoBASS_ChannelSeconds2Bytes24(Handle.i, Pos.d)
Prototype.q ProtoBASS_ChannelSeconds2Bytes23(Handle.i, Pos.f)
Prototype.q ProtoBASS_ChannelGetLength23(Handle.i)
Prototype.q ProtoBASS_ChannelGetLength24(Handle.i, Mode.i)
Prototype.q ProtoBASS_ChannelGetPosition23(Handle.i)
Prototype.q ProtoBASS_ChannelGetPosition24(Handle.i, Mode.i)
Prototype.q ProtoBASS_StreamGetFilePosition24(Handle.i, Mode.i)
Prototype.i ProtoBASS_ChannelSetPosition23(Handle.i, Pos.q)
Prototype.i ProtoBASS_ChannelSetPosition24(Handle.i, Pos.q, Mode.i)
Prototype.i ProtoBASS_ChannelSetAttribute24(Handle.i, attrib.i, Value.f)
Prototype.i ProtoBASS_ChannelSetAttributes23(Handle.i, frequ.w, Volume.w, Pan.w)
Prototype.i ProtoBASS_MusicLoad24(Mem.i, *File, offset.q, length.i, flags.i, frequ.i)
Prototype.i ProtoBASSCreateFile24(Mem.i, *File, offset.q, length.q, flags.i)
CompilerIf #BASS_UseMidi
  Prototype.i ProtoBASSCreateFileMidi24(Mem.i, *File, offset.q, length.q, flags.i, freq.i)
  CompilerEndIf

Import "kernel32.lib"
  CreateFileW.i (*lpFileName, dwDesiredAccess.i, dwShareMode.i, *lpSecurityAttributes, dwCreationDisposition.i, dwFlagsAndAttributes.i, hTemplateFile.i)
  EndImport


ProcedureDLL AttachProcess(Instance)
  ;OpenConsole()
  ;PrintN("Reopened!")
  Global *BassDLL
  Global OSToNew
  Global HasPreDone.i
  Global MidiCounter.i
  Global WasInited.i

  #BASS_POS_BYTE = 0
  #BASS_ATTRIB_VOL = 2
  #BASS_UNICODE = $80000000
  #OutPutListMax = 32
  #SoundFontListMax = 128
  Global OutPutListCount.i
  Global SoundFontListCount.i
  Global CurSoundFont.i
  Global HadMidiPluginOnce.i

  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
    Global Dim OutPutList.i(#OutPutListMax)
    CompilerElse
    Global Dim OutPutList.s(#OutPutListMax)
    CompilerEndIf
  Global Dim SoundFontList.i(#SoundFontListMax)
  Global Dim SoundFontCaps.w(#SoundFontListMax)
  Global Dim SoundFontSize.q(#SoundFontListMax)
  Global SoundFontListFlags.i

  Global InfoString.s
  CompilerIf #ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
    Global InfoStringW.i ;= AllocateMemory(1024)
    CompilerEndIf
  
  Structure ctSSSongInfoStruct
    FormatOK.l
    Format_Frequency.l
    Format_BitRate.l
    Format_Channels.l
    Format_VBR.l
    Format_QualityMulti.l
    TagOK.l
    Tag_Year.l
    Tag_TrackID.l
    Tag_Artist.i
    Tag_Title.i
    Tag_Album.i
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    IR_Name.i
    IR_URL.i
CompilerEndIf
    EndStructure

  Structure RealLoaderParams
    mode.i
    Filename.i
    Flags.i
    UnicodeFlag.i
    SongPointer.i
    IsThread.i
    EndStructure

  ;CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  ;  #ctSSLayer_SpectrumArrayCountX = #ctSSLayer_SpectrumArrayCount - 1
  ;  CompilerEndIf

  #ctSSLayer_MaxIDs = 16
  #ctSSLayer_MaxIDsX = #ctSSLayer_MaxIDs - 1
  #KeepAliveTime = 1000
  Global IsUnicode.i

  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    Structure BASS_CHANNELINFO
      freq.l
      chans.l
      flags.l
      ctype.l
      origres.l
      hPlugin.l
      sample.l
      *filename
      EndStructure
    
    Global MemAlbum.i
    Global MemArtst.i
    Global MemTitle.i
    Global MemIRNam.i
    Global MemIRURL.i
    Global TagRVersion.i
    CompilerEndIf
  
  CompilerIf #BASS_UseMidi
    Structure WIN32_FIND_DATAW Extends WIN32_FIND_DATA
      ExtraBytes.b[275]
      EndStructure
    Structure BASS_MIDI_FONTINFO
      *name
      *copyright
      *comment
      presets.l
      samsize.l
      samload.l
      samtype.l
      EndStructure
    
    Structure BASS_MIDI_FONT
      hFont.l
      preset.l
      bank.l
      EndStructure

    Global *CBSoundFontFileW
    Global CBSoundFontSize.q
    Global hCBSoundFontFile.i
    CompilerEndIf

  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    ;Structure BASS_CD_INFO
      ;vendor.l        ; manufacturer
      ;product.l       ; model
      ;rev.l           ; revision
      ;letter.l        ; drive letter
      ;rwflags.l       ; read/write capability flags
      ;canopen.l       ; BASS_CD_DOOR_OPEN/CLOSE is supported?
      ;canlock.l       ; BASS_CD_DOOR_LOCK/UNLOCK is supported?
      ;maxspeed.l      ; max read speed (KB/s)
      ;cache.l         ; cache size (KB)
      ;cdtext.l        ; can read CD-TEXT
      ;EndStructure
    CompilerEndIf

    
    
  Global *BASS_StreamCreateFile
  CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Global *BASS_StreamCreateURL
    Global *BASS_PluginOpus
    CompilerEndIf
  Global *BASS_ChannelPlay
  Global *BASS_StreamFree
  Global *BASS_ChannelPause
  Global *BASS_ChannelIsActive
  Global *BASS_MusicLoad23
  Global *BASS_MusicSetAttribute23
  Global *BASS_MusicFree
  Global *BASS_ChannelGetData
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    Global *BASS_ChannelGetInfo
    Global *BASS_GetConfig
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    Global *BASS_StreamChannelGetTags
    CompilerEndIf


  Global xSystem.i

  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Global IsCDing.i
    CompilerEndIf

  #BASS_ACTIVE_STOPPED = 0
  #BASS_ACTIVE_STALLED = 2
  #BASS_ATTRIB_MUSIC_PANSEP = $101

  Structure tSong
    Mode.i
    Pointer.i
    ExtraA.i
    Size.i
    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      Format_QualityMulti.f
      CompilerEndIf
    FileSize.i
    ShouldPlay.i
    CompilerIf #ctSSLayer_CompiledFeature_InetStreams
      CurVolume.i
      CompilerEndIf
    ThreadState.i
    EndStructure

  ;Global Dim Song.tSong(#ctSSLayer_MaxIDsX)
  Global xSysPath.s
  Global xNoDirectX.i
  Global VersionID.i
  Global RevisionID.i
  
  Global *BASS_MPC
  Global *BASS_MPC_StreamCreateFile
  Global *BASS_WMA
  Global *BASS_WMA_StreamCreateFile
  Global *BASS_AAC
  Global *BASS_AAC_StreamCreateFile  
  ;Global *BASS_MP4_StreamCreateFile
  Global *BASS_AC3
  Global *BASS_AC3_StreamCreateFile
  Global *BASS_APE
  Global *BASS_APE_StreamCreateFile
  Global *BASS_FLAC
  Global *BASS_FLAC_StreamCreateFile
  Global *BASS_WV
  Global *BASS_WV_StreamCreateFile
  Global *BASS_OPUS
  Global *BASS_OPUS_StreamCreateFile
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    Global *TAGS
    Global *TAGS_Read
    CompilerEndIf
  CompilerIf #BASS_UseMidi    
    Global *BASS_MIDI
    Global *BASS_MIDI_StreamCreateFile
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Global *BASS_CD
    Global *BASS_CD_StreamCreateFile
    CompilerEndIf


  #BassLayer_ModeTracker = $1
  CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    #BassLayer_ModeINet = $3
    CompilerEndIf
  #BassLayer_ModeMIDI = $4
  #BassLayer_ModeCDDA  = $5

  #BassLayer_ModeStream = $10
    #BassLayer_ModeMPC  = $11
    #BassLayer_ModeWMA  = $12
    #BassLayer_ModeFLAC = $13
    #BassLayer_ModeAAC  = $14
;    #BassLayer_ModeMP4 = $15
    #BassLayer_ModeAPE  = $16
    #BassLayer_ModeAC3  = $17
    #BassLayer_ModeWV   = $18
    #BassLayer_ModeOPUS = $19
  EndProcedure

XIncludeFile "ctSSLayer_Common01.pb"
XIncludeFile "ctSSLayer_Common_Debugger.pb"
XIncludeFile "ctSSLayer_Common_TestForDll.pb"

Procedure TestForDLL_BASS_Ex(DllFilename.s, *ptrToLibPtr, *ptrToFunctionPtr, FunctionName.s)
  Define.i xLong1
  Define.i xLong2
  
  ;Debug "Ver: " + Hex(VersionID) + " " + Str(VersionID) + " File: " + DllFilename
  If TestForDll(DllFilename, VersionID, VersionID)
    xLong1 = OpenLibrary(#PB_Any, DllFilename)
    ;Debug "  OpenLibrary (" + DllFilename + "): " + Str(xLong1)
    If xLong1
      xLong2 = GetFunction(xLong1, FunctionName)
      ;Debug "GetFunction: (" + FunctionName + ")" + Str(xLong1)
      If xLong2
        PokeL(*ptrToLibPtr, xLong1)
        PokeL(*ptrToFunctionPtr, xLong2)
        Else
        CloseLibrary(xLong1)
        EndIf
      EndIf
    EndIf
  EndProcedure

CompilerIf #BASS_UseMidi    
  ProcedureDLL.i FindBestSoundFontW(*ptrDirEx, PatchAt, DetectBest)
    Define.i xLong1
    Define.i xBool1
    Define.i xLong2
    Define.i xLong3
    Define.i xLong4
    Define.q xQuad1
    ;Define.i xLong5
    Define.WIN32_FIND_DATAW xType1
  
;Debug "Reading..." + PeekS(*ptrDirEx, -1, #PB_Unicode)
    xType1\dwFileAttributes = $2F
    xLong1 = FindFirstFileW(*ptrDirEx, @xType1)
    If Not xLong1 = -1
      Repeat
        PokeL(@xQuad1, xType1\nFileSizeLow)
        PokeL(@xQuad1 + 4, xType1\nFileSizeHigh)
;Debug "Found: " + PeekS(@xType1\cFileName[0], -1, #PB_Unicode) + ", size: " + StrU(xQuad1)
        If SoundFontListCount < #SoundFontListMax
;SoundFontListFlags = 0
          If SoundFontListFlags & 1
            xLong3 = 0
            For xLong2 = 0 To SoundFontListCount - 1
              If xQuad1 > SoundFontSize(xLong2)
                xLong3 = xLong2 + 1
                ElseIf SoundFontSize(xLong2) = xQuad1
                If Not lstrcmpiW(SoundFontList(xLong2) + SoundFontCaps(xLong2), @xType1\cFileName[0])
                  xLong3 = -1
                  Break
                  EndIf
                ;Else
                ;Break
                EndIf
              Next
            Else
            xLong3 = SoundFontListCount
            For xLong2 = 0 To SoundFontListCount - 1
              xLong4 = lstrcmpiW(SoundFontList(xLong2) + SoundFontCaps(xLong2), @xType1\cFileName[0])
              If xLong4 > 0
                xLong3 = xLong2
                Break
                ElseIf xLong4 = 0
                xLong3 = -1
                Break
                EndIf
              Next
            EndIf
;Debug Str(xLong3) + "/" + Str(SoundFontListCount+1)
          If Not xLong3 = -1
            CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
              RtlMoveMemory_(@SoundFontList(xLong3 + 1), @SoundFontList(xLong3), (SoundFontListCount - xLong3) << 3)
              RtlMoveMemory_(@SoundFontCaps(xLong3 + 1), @SoundFontCaps(xLong3), (SoundFontListCount - xLong3) << 1)
              RtlMoveMemory_(@SoundFontSize(xLong3 + 1), @SoundFontSize(xLong3), (SoundFontListCount - xLong3) << 3)
              CompilerElse
              RtlMoveMemory_(@SoundFontList(xLong3 + 1), @SoundFontList(xLong3), (SoundFontListCount - xLong3) << 2)
              RtlMoveMemory_(@SoundFontCaps(xLong3 + 1), @SoundFontCaps(xLong3), (SoundFontListCount - xLong3) << 1)
              RtlMoveMemory_(@SoundFontSize(xLong3 + 1), @SoundFontSize(xLong3), (SoundFontListCount - xLong3) << 3)
              CompilerEndIf
            lstrcpyW(*ptrDirEx + PatchAt, @xType1\cFileName[0])
            SoundFontCaps(xLong3) = PatchAt
            SoundFontList(xLong3) = LocalAllocStringWFromW(*ptrDirEx)
            SoundFontSize(xLong3) = xQuad1
            SoundFontListCount + 1
            EndIf
          EndIf
        
        If DetectBest And xQuad1 > CBSoundFontSize
          lstrcpyW(*ptrDirEx + PatchAt, @xType1\cFileName[0])
          If *CBSoundFontFileW
            FreeMemory(*CBSoundFontFileW)
            EndIf
          *CBSoundFontFileW = LocalAllocStringWFromW(*ptrDirEx)
          CBSoundFontSize = xQuad1
          xBool1 = 1
          EndIf
        Until FindNextFileW(xLong1, @xType1) = 0
      FindClose_(xLong1)
      EndIf
    FreeMemory(*ptrDirEx)
    EndProcedure
  
  ProcedureDLL.i FindBestSoundFontA(*ptrDirEx, PatchAt, DetectBest)
    Define.i xLong1
    Define.i xLong2
    Define.i xLong3
    Define.i xLong4
    Define.i xBool1
    Define.q xQuad1
    Define.WIN32_FIND_DATA xType1
    
    xType1\dwFileAttributes = $2F
    xLong1 = FindFirstFile_(*ptrDirEx, @xType1)
    If Not xLong1 = -1
      Repeat
        PokeL(@xQuad1, xType1\nFileSizeLow)
        PokeL(@xQuad1 + 4, xType1\nFileSizeHigh)
        ;Debug "Found: " + PeekS(@xType1\cFileName[0])
        If SoundFontListCount < #SoundFontListMax
          If SoundFontListFlags & 1
            xLong3 = 0
            For xLong2 = 0 To SoundFontListCount - 1
              If xQuad1 > SoundFontSize(xLong2)
                xLong3 = xLong2 + 1
                ElseIf SoundFontSize(xLong2) = xQuad1
                If Not lstrcmpi_(SoundFontList(xLong2) + SoundFontCaps(xLong2), @xType1\cFileName[0])
                  xLong3 = -1
                  Break
                  EndIf
                ;Else
                ;Break
                EndIf
              Next
            Else
            xLong3 = SoundFontListCount
            For xLong2 = 0 To SoundFontListCount - 1
              xLong4 = lstrcmpi_(SoundFontList(xLong2) + SoundFontCaps(xLong2), @xType1\cFileName[0])
              If xLong4 > 0
                xLong3 = xLong2
                Break
                ElseIf xLong4 = 0
                xLong3 = -1
                Break
                EndIf
              Next
            EndIf
;Debug Str(xLong3) + "/" + Str(SoundFontListCount+1)
          If Not xLong3 = -1
            RtlMoveMemory_(@SoundFontList(xLong3 + 1), @SoundFontList(xLong3), (SoundFontListCount - xLong3) << 2)
            RtlMoveMemory_(@SoundFontCaps(xLong3 + 1), @SoundFontCaps(xLong3), (SoundFontListCount - xLong3) << 1)
            RtlMoveMemory_(@SoundFontSize(xLong3 + 1), @SoundFontSize(xLong3), (SoundFontListCount - xLong3) << 3)
            lstrcpy_(*ptrDirEx + PatchAt, @xType1\cFileName[0])
            SoundFontCaps(xLong3) = PatchAt
            SoundFontList(xLong3) = LocalAllocStringWFromAnsiOrUTF8Mem(*ptrDirEx, #CP_ACP)
            SoundFontSize(xLong3) = xQuad1
            SoundFontListCount + 1
            EndIf
          EndIf
        If DetectBest And xQuad1 > CBSoundFontSize
          lstrcpy_(*ptrDirEx + PatchAt, @xType1\cFileName[0])
          CBSoundFontSize = xQuad1
          xBool1 = 1
          EndIf
        Until FindNextFile_(xLong1, @xType1) = 0
      FindClose_(xLong1)
      EndIf
    If xBool1
      If *CBSoundFontFileW
        FreeMemory(*CBSoundFontFileW)
        EndIf
      *CBSoundFontFileW = LocalAllocStringWFromAnsiOrUTF8Mem(*ptrDirEx, #CP_ACP)
      EndIf
    FreeMemory(*ptrDirEx)
    EndProcedure

  Procedure GetSoundFonts(DetectBest.i)
    Define.i xStep
    Define.i xLong1

    SoundFontListCount = 0
    For xStep = 0 To 1
      If DetectBest
        CBSoundFontSize = 0
        EndIf
      If IsUnicode
        Define *Mem = AllocateMemory(2060)
        If *Mem
          If xStep
            xLong1 = GetModuleFileNameW(GetModuleHandleW(0), *Mem, 2048)
            CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
              EnableASM
                MOV rax, *Mem
                PUSH rbx
                MOV bx, 92
                DEC rax
                DEC rax
                XOr rdx, rdx
      !StripWLoopW1:
                INC rax
                INC rax
                MOV cx, [rax]
                Or cx, cx
                !JZ StripWExitW1
                CMP cx, bx
                !JNE StripWLoopW1
                MOV rdx, rax
                !JMP StripWLoopW1
      !StripWExitW1:
                POP rbx
                MOV xLong1, rdx
                DisableASM
              CompilerElse
              EnableASM
                MOV eax, *Mem
                PUSH ebx
                MOV bx, 92
                DEC eax
                DEC eax
                XOr edx, edx
      !StripWLoopW1:
                INC eax
                INC eax
                MOV cx, [eax]
                Or cx, cx
                !JZ StripWExitW1
                CMP cx, bx
                !JNE StripWLoopW1
                MOV edx, eax
                !JMP StripWLoopW1
      !StripWExitW1:
                POP ebx
                MOV xLong1, edx
                DisableASM
              CompilerEndIf
            
            If xLong1
              ;PokeB(xLong1 + 1, 0)
              xLong1 = xLong1 - *Mem + 2
              EndIf
            Else
            xLong1 = GetSystemDirectoryW(*Mem, 2048)
            If xLong1
              xLong1 * 2
              If Not PeekW(*Mem + xLong1 - 2) = 92
                PokeW(*Mem + xLong1, 92)
                xLong1 + 2
                EndIf
              EndIf
            EndIf
          If xLong1
    ;Debug PeekS(*Mem, -1, #PB_Unicode)
            ;Define.s xChar1 = PeekS(*Mem, -1, #PB_Unicode)
            PokeS(*Mem + xLong1, "*.sf2", -1, #PB_Unicode)
    ;Debug PeekS(*Mem, -1, #PB_Unicode)
            FindBestSoundFontW(*Mem, xLong1, DetectBest)
            Else
            FreeMemory(*Mem)
            EndIf
          EndIf
        Else
        Define *Mem = AllocateMemory(1030)
        If *Mem
          If xStep
            xLong1 = GetModuleFileName_(GetModuleHandle_(0), *Mem, 1024)
            ;Debug *Mem
            CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
              EnableASM
                MOV rax, *Mem
                XOr rcx, rcx
                MOV ch, 92
                DEC rax
                XOr rdx, rdx
      !StripALoopA1:
                INC rax
                MOV cl, [rax]
                Or cl, cl
                !JZ StripAExitA1
                CMP cl, ch
                !JNE StripALoopA1
                MOV rdx, rax
                !JMP StripALoopA1
      !StripAExitA1:
                MOV xLong1, rdx
                DisableASM
              CompilerElse
              EnableASM
                MOV eax, *Mem
                XOr ecx, ecx
                MOV ch, 92
                DEC eax
                XOr edx, edx
      !StripALoopA1:
                INC eax
                MOV cl, [eax]
                Or cl, cl
                !JZ StripAExitA1
                CMP cl, ch
                !JNE StripALoopA1
                MOV edx, eax
                !JMP StripALoopA1
      !StripAExitA1:
                MOV xLong1, edx
                DisableASM
              CompilerEndIf
            If xLong1
              ;PokeB(xLong1 + 1, 0)
              xLong1 = xLong1 - *Mem + 1
              EndIf
            Else
            xLong1 = GetSystemDirectory_(*Mem, 1024)
            If xLong1
              If Not PeekB(*Mem + xLong1 - 1) = 92
                PokeB(*Mem + xLong1, 92)
                xLong1 + 1
                EndIf
              EndIf
            EndIf
          If xLong1
;    Debug PeekS(*Mem)
            Define.s xChar1 = PeekS(*Mem)
            PokeS(*Mem + xLong1, "*.sf2")
;    Debug PeekS(*Mem)
            FindBestSoundFontA(*Mem, xLong1, DetectBest)
            Else
            FreeMemory(*Mem)
            EndIf
          EndIf
        EndIf
      Next
    EndProcedure
  CompilerEndIf

CompilerIf #BASS_UseMidi
  Procedure.i ApplySoundFont(FontID);, IsDefault)
    Define.i xResult
    Define.BASS_MIDI_FONT xType1
    Define.s xChar1

    If IsUnicode
      SendToDebugger("Setting MIDI Soundfont: " + PeekS(SoundFontList(FontID), -1, #PB_Unicode), #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Snd)
      xType1\hFont = CallFunction(*BASS_MIDI, "BASS_MIDI_FontInit", SoundFontList(FontID), #BASS_UNICODE)
      Else
      xChar1 = PeekS(SoundFontList(FontID), -1, #PB_Unicode)
      SendToDebugger("Setting MIDI Soundfont: " + xChar1, #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Snd)
      xType1\hFont = CallFunction(*BASS_MIDI, "BASS_MIDI_FontInit", @xChar1, 0)
      EndIf

    If xType1\hFont
      xType1\preset= -1
      If CallFunction(*BASS_MIDI, "BASS_MIDI_StreamSetFonts", 0, @xType1, 1)
        SendToDebugger("ok", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
        If hCBSoundFontFile
          SendToDebugger("Releasing old MIDI Soundfont", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Snd)
          CallFunction(*BASS_MIDI, "BASS_MIDI_FontFree", hCBSoundFontFile)
          EndIf
        hCBSoundFontFile = xType1\hFont
        If CurSoundFont
          FreeMemory(CurSoundFont)
          EndIf
        CurSoundFont = LocalAllocStringWFromW(SoundFontList(FontID))
        xResult = #True
        Else
        CallFunction(*BASS_MIDI, "BASS_MIDI_FontFree", xType1\hFont)
        EndIf
      Else
      SendToDebugger("soundfont rejected", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      EndIf
;      SendToDebugger("no soundfont available", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
;      EndIf
    ProcedureReturn xResult
    EndProcedure

  Procedure.i ApplyBestSoundFont()
    Define.i xResult
    Define.i xLong1
  
    If *CBSoundFontFileW And SoundFontListCount
      For xLong1 = 0 To SoundFontListCount - 1
        If SoundFontList(xLong1)
          If lstrcmpiW(*CBSoundFontFileW, SoundFontList(xLong1)) = 0
            ProcedureReturn ApplySoundFont(xLong1)
            EndIf
          EndIf
        Next
      ProcedureReturn ApplySoundFont(0)
      EndIf
    EndProcedure
  CompilerEndIf

Procedure GetPreFuncs()
  MidiCounter = 0
  If Not HasPreDone
    HasPreDone = 1
    
    TestForDLL_BASS_Ex("bass_mpc.dll", @*BASS_MPC, @*BASS_MPC_StreamCreateFile, "BASS_MPC_StreamCreateFile")
    If TestForDll(xSysPath + "wmasf.dll", 7.0001)
      TestForDLL_BASS_Ex("basswma.dll", @*BASS_WMA, @*BASS_WMA_StreamCreateFile, "BASS_WMA_StreamCreateFile")
      EndIf
    TestForDLL_BASS_Ex("bass_aac.dll", @*BASS_AAC, @*BASS_AAC_StreamCreateFile, "BASS_AAC_StreamCreateFile")
    ;If *BASS_AAC_StreamCreateFile
    ;  *BASS_MP4_StreamCreateFile = GetFunction(*BASS_AAC, "BASS_MP4_StreamCreateFile")
    ;  Else
    ;  TestForDLL_BASS_Ex("bass_aac.dll", @*BASS_AAC, @*BASS_MP4_StreamCreateFile, "BASS_MP4_StreamCreateFile")
    ;  EndIf
    TestForDLL_BASS_Ex("bass_ac3.dll", @*BASS_AC3, @*BASS_AC3_StreamCreateFile, "BASS_AC3_StreamCreateFile")
    TestForDLL_BASS_Ex("bass_ape.dll", @*BASS_APE, @*BASS_APE_StreamCreateFile, "BASS_APE_StreamCreateFile")
    TestForDLL_BASS_Ex("bassflac.dll", @*BASS_FLAC, @*BASS_FLAC_StreamCreateFile, "BASS_FLAC_StreamCreateFile")
    TestForDLL_BASS_Ex("basswv.dll", @*BASS_WV, @*BASS_WV_StreamCreateFile, "BASS_WV_StreamCreateFile")
    TestForDLL_BASS_Ex("bassopus.dll", @*BASS_OPUS, @*BASS_OPUS_StreamCreateFile, "BASS_OPUS_StreamCreateFile")
;Debug "*BASS_OPUS_StreamCreateFile: " + Str(*BASS_OPUS_StreamCreateFile)
    If *BASS_OPUS_StreamCreateFile
      ;*BASS_PluginOpus = GetFunction(*BassDLL, "BASS_PluginLoad")
      *BASS_PluginOpus = CallFunction(*BassDLL, "BASS_PluginLoad", @"bassopus.dll", 0)
      EndIf
;Debug "*BASS_PluginOpus: " + Str(*BASS_PluginOpus)

    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      *TAGS = OpenLibrary(#PB_Any, "tags.dll")
      ;Debug "  OpenLibrary (" + "tags.dll" + "): " + Str(*TAGS)
      If *TAGS
        *TAGS_Read = GetFunction(*TAGS, "TAGS_GetVersion")
        If *TAGS_Read
          TagRVersion = CallFunctionFast(*TAGS_Read)
          *TAGS_Read = GetFunction(*TAGS, "TAGS_Read")
          EndIf
        
        ;Debug "GetFunction: (" + "TAGS_Read" + ")" + Str(*TAGS)
        If *TAGS_Read = 0
          CloseLibrary(*TAGS)
          *TAGS = 0
          EndIf
        EndIf
      ;TestForDLL_BASS_Ex("tags.dll", @*TAGS, @*TAGS_Read, "TAGS_Read")
      CompilerEndIf
    
    CompilerIf #BASS_UseMidi    
      TestForDLL_BASS_Ex("bassmidi.dll", @*BASS_MIDI, @*BASS_MIDI_StreamCreateFile, "BASS_MIDI_StreamCreateFile")
      If *BASS_MIDI_StreamCreateFile
        SendToDebugger("MIDI plugin ok, checking soundfont", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd)
        SoundFontListFlags = 0
        HadMidiPluginOnce = #True
        GetSoundFonts(#True)
        If Not ApplyBestSoundFont()
          CloseLibrary(*BASS_MIDI)
          *BASS_MIDI_StreamCreateFile = 0
          SoundFontListCount = 0
          EndIf
        EndIf
      CompilerEndIf
    CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      TestForDLL_BASS_Ex("basscd.dll", @*BASS_CD, @*BASS_CD_StreamCreateFile, "BASS_CD_StreamCreateFile")
      CompilerEndIf
    EndIf
  EndProcedure

Procedure GetFuncs()
  *BASS_ChannelPlay = GetFunction(*BassDLL, "BASS_ChannelPlay")
  *BASS_StreamFree = GetFunction(*BassDLL, "BASS_StreamFree")
  *BASS_ChannelPause = GetFunction(*BassDLL, "BASS_ChannelPause")
  *BASS_ChannelIsActive = GetFunction(*BassDLL, "BASS_ChannelIsActive")
  *BASS_MusicFree = GetFunction(*BassDLL, "BASS_MusicFree")
  *BASS_ChannelGetData = GetFunction(*BassDLL, "BASS_ChannelGetData")
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    *BASS_ChannelGetInfo = GetFunction(*BassDLL, "BASS_ChannelGetInfo")
    *BASS_GetConfig = GetFunction(*BassDLL, "BASS_GetConfig")
    CompilerEndIf

  If VersionID > $20003
    Global BASS_ChannelGetLength24.ProtoBASS_ChannelGetLength24 = GetFunction(*BassDLL, "BASS_ChannelGetLength")
    Global BASS_StreamGetFilePosition24.ProtoBASS_StreamGetFilePosition24 = GetFunction(*BassDLL, "BASS_StreamGetFilePosition")
    Global BASS_ChannelGetPosition24.ProtoBASS_ChannelGetPosition24 = GetFunction(*BassDLL, "BASS_ChannelGetPosition")
    Global BASS_ChannelSetPosition24.ProtoBASS_ChannelSetPosition24 = GetFunction(*BassDLL, "BASS_ChannelSetPosition")
    Global BASS_MusicLoad24.ProtoBASS_MusicLoad24 = GetFunction(*BassDLL, "BASS_MusicLoad")
    Global BASS_ChannelBytes2Seconds24.ProtoBASS_ChannelBytes2Seconds24 = GetFunction(*BassDLL, "BASS_ChannelBytes2Seconds")
    Global BASS_ChannelSeconds2Bytes24.ProtoBASS_ChannelSeconds2Bytes24 = GetFunction(*BassDLL, "BASS_ChannelSeconds2Bytes")
    Global BASS_ChannelSetAttribute24.ProtoBASS_ChannelSetAttribute24 = GetFunction(*BassDLL, "BASS_ChannelSetAttribute")
    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      Global *BASS_StreamChannelGetTags = GetFunction(*BassDLL, "BASS_ChannelGetTags")
      CompilerEndIf
    Else
    Global BASS_ChannelGetLength23.ProtoBASS_ChannelGetLength23 = GetFunction(*BassDLL, "BASS_ChannelGetLength")
    Global *BASS_StreamGetFilePosition23 = GetFunction(*BassDLL, "BASS_StreamGetFilePosition")
    Global BASS_ChannelGetPosition23.ProtoBASS_ChannelGetPosition23 = GetFunction(*BassDLL, "BASS_ChannelGetPosition")
    Global BASS_ChannelSetPosition23.ProtoBASS_ChannelSetPosition23 = GetFunction(*BassDLL, "BASS_ChannelSetPosition")
    *BASS_MusicLoad23 = GetFunction(*BassDLL, "BASS_MusicLoad")
    Global BASS_ChannelBytes2Seconds23.ProtoBASS_ChannelBytes2Seconds23 = GetFunction(*BassDLL, "BASS_ChannelBytes2Seconds")
    Global BASS_ChannelSeconds2Bytes23.ProtoBASS_ChannelSeconds2Bytes23 = GetFunction(*BassDLL, "BASS_ChannelSeconds2Bytes")
    Global BASS_ChannelSetAttributes23.ProtoBASS_ChannelSetAttributes23 = GetFunction(*BassDLL, "BASS_ChannelSetAttributes")
    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      Global *BASS_StreamChannelGetTags = GetFunction(*BassDLL, "BASS_StreamGetTags")
      CompilerEndIf
    EndIf
  *BASS_StreamCreateFile = GetFunction(*BassDLL, "BASS_StreamCreateFile")
  CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    *BASS_StreamCreateURL = GetFunction(*BassDLL, "BASS_StreamCreateURL")
    CompilerEndIf
  EndProcedure

Procedure ClearOutputList()
  Define.i xLong1
  
  For xLong1 = 0 To OutPutListCount - 1
    CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
      If OutPutList(xLong1)
        FreeMemory(OutPutList(xLong1))
        OutPutList(xLong1) = 0
        EndIf
      CompilerElse
      OutPutList(xLong1) = ""
      CompilerEndIf
    Next
  OutPutListCount = 0
  EndProcedure

Procedure ClearSoundFontList()
  Define.i xLong1
  
  For xLong1 = 0 To OutPutListCount - 1
    If SoundFontList(xLong1)
      FreeMemory(SoundFontList(xLong1))
      SoundFontList(xLong1) = 0
      EndIf
    Next
  SoundFontListCount = 0
  EndProcedure

ProcedureDLL DetachProcess(Instance)
  EndProcedure

ProcedureDLL AttachThread(Instance)
  EndProcedure

ProcedureDLL DetachThread(Instance)
  EndProcedure

ProcedureDLL.i ctSSLayer_CanUseItem(Index.i)
  Define.i ctSSLayer_CanUseItem

  Select Index
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case 0 ; cdda
      ctSSLayer_CanUseItem = 1
    Case 1 ; jitter
      ctSSLayer_CanUseItem = 0
    Case 2 ; runtimecdda/jitter update
      ctSSLayer_CanUseItem = 0
CompilerEndIf
    Case 3 ; checkaccuratestreams
      ctSSLayer_CanUseItem = 2
CompilerIf #ctSSLayer_CompiledFeature_Spectrum
    Case 4 ; UseSpectrum   (disabled / 1=mono / 2=stereo)
      ctSSLayer_CanUseItem = 1
CompilerEndIf
;    Case 5 ' UseGetCDDtracks
;      ctSSLayer_CanUseItem = 0&
    Case 6 ; ModuleTimeHandling:
      ; 1 = Patterns
      ; 2 = Elapsed time (only)
      ; 4 = Real times
      ctSSLayer_CanUseItem = 4
    Case 7 ; maxDeviceCount
      ctSSLayer_CanUseItem = OutPutListCount
    Case 9 ; MidiXFade
      ctSSLayer_CanUseItem = 1 ;testing
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case $A ; SupportsCD Or CDDA (0/1)
      If *BASS_CD_StreamCreateFile
        ctSSLayer_CanUseItem = 1
        EndIf
      ;ctSSLayer_CanUseItem = 1
CompilerEndIf
    Case $C ; KeepAliveTime: leave channel stopped before unloading (buffer!)
      ctSSLayer_CanUseItem = #KeepAliveTime
    Case $D      ;#ctSSLayer_MaxIDs ; for future use, currently fixed
      ctSSLayer_CanUseItem = #ctSSLayer_MaxIDs
CompilerIf #ctSSLayer_CompiledFeature_RefreshDeviceList
    ;Case $E
CompilerEndIf
;CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
;    Case $10
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Case $11 ; Internet/streams; 1 = yes!
      ctSSLayer_CanUseItem = 1
CompilerEndIf
    Case $12
      ctSSLayer_CanUseItem = 2
;CompilerEndIf
CompilerIf #BASS_UseMidi
    Case $18 ; Midi soundfonts...
      ctSSLayer_CanUseItem = HadMidiPluginOnce
    Case $19 ; Midi soundfonts runtime updateable...
      ctSSLayer_CanUseItem = HadMidiPluginOnce
    Case $1A ; maxSoundFontCount
      ctSSLayer_CanUseItem = SoundFontListCount
CompilerEndIf
    Case $20 ; ctSSLayer_Useable
      ;    10 = should update
      ;    11 = untested
      ;    12 = new & untested
      ;    13 = hasrestrictions, up/downgrade

      ;  < 20 = ok

      ;    20 (DirectX missing)
      ;    21 (DirectX to old (or missing))
      ;    30 = to old
      ;    31 = incompatible
      ;    32 = to new
      ;    90 = cannot load (generic something missing)
      ;         should have high priority!


      ; +$1000000 = retry (dll not found or can retry)
      If OSToNew
        ctSSLayer_CanUseItem = 32
        Else
        Select VersionID
          Case 0, -1
            ctSSLayer_CanUseItem = 90
          Case $20002, $20003, $20004
            If xNoDirectX
              ctSSLayer_CanUseItem = 21
              ;Else
              ;ctSSLayer_CanUseItem = $0
              EndIf
          Case 0 To $20001
            ctSSLayer_CanUseItem = 30
          Default
            ctSSLayer_CanUseItem = 32
          EndSelect
        EndIf  
      EndSelect
  ProcedureReturn ctSSLayer_CanUseItem
  EndProcedure

ProcedureDLL ctSSLayer_Close(Fast.i)
  If *BassDLL
    If xSystem
      ; Calling after plugin unloads gets an error... so some plugins do?
      SendToDebugger("MIDI Soundfont", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Snd)
      CallFunction(*BassDLL, "BASS_Free")
      xSystem = 0
      EndIf

    CompilerIf #BASS_UseMidi
      If *BASS_MIDI_StreamCreateFile
        If hCBSoundFontFile
          SendToDebugger("Releasing MIDI Soundfont", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Snd)
          CallFunction(*BASS_MIDI, "BASS_MIDI_FontFree", hCBSoundFontFile)
          EndIf
        EndIf
      CompilerEndIf

    SendToDebugger("Unloading plugins...", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Snd)

    If *BASS_MPC_StreamCreateFile
      SendToDebugger("MPC", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      CloseLibrary(*BASS_MPC)
      *BASS_MPC_StreamCreateFile = 0
      EndIf
    If *BASS_WMA_StreamCreateFile
      SendToDebugger("WMA", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      CloseLibrary(*BASS_WMA)
      *BASS_WMA_StreamCreateFile = 0
      EndIf
    ;If *BASS_AAC_StreamCreateFile Or *BASS_MP4_StreamCreateFile
    ;  SendToDebugger("AAC", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
    ;  CloseLibrary(*BASS_AAC)
    ;  *BASS_AAC_StreamCreateFile = 0
    ;  EndIf
    If *BASS_AAC_StreamCreateFile
      SendToDebugger("AAC", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      CloseLibrary(*BASS_AAC)
      *BASS_AAC_StreamCreateFile = 0
      EndIf
    If *BASS_AC3_StreamCreateFile
      SendToDebugger("AC3", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      CloseLibrary(*BASS_AC3)
      *BASS_AC3_StreamCreateFile = 0
      EndIf
    If *BASS_APE_StreamCreateFile
      SendToDebugger("APE", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      CloseLibrary(*BASS_APE)
      *BASS_APE_StreamCreateFile = 0
      EndIf
    If *BASS_FLAC_StreamCreateFile
      SendToDebugger("FLAC", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      CloseLibrary(*BASS_FLAC)
      *BASS_FLAC_StreamCreateFile = 0
      EndIf
    If *BASS_WV_StreamCreateFile
      SendToDebugger("WV", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      CloseLibrary(*BASS_WV)
      *BASS_WV_StreamCreateFile = 0
      EndIf
    If *BASS_OPUS_StreamCreateFile
      SendToDebugger("OPUS", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
      CloseLibrary(*BASS_OPUS)
      *BASS_OPUS_StreamCreateFile = 0
      If *BASS_PluginOpus
        CallFunction(*BassDLL, "BASS_PluginFree", *BASS_PluginOpus)
        EndIf
      EndIf
    *BASS_PluginOpus = 0

    CloseLibrary(*BassDLL)
    *BassDLL = 0
    WasInited = #True
    CompilerIf #BASS_UseMidi
      If *BASS_MIDI_StreamCreateFile
        ;If hCBSoundFontFile
          ;CallFunction(*BASS_MIDI, "BASS_MIDI_FontFree", hCBSoundFontFile)
          ;EndIf
          SendToDebugger("MIDI", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
          Sleep_(1) ; min. 1, Otherwise might crash when quitting immediatelly after midi playback and main window minimized on win98 and alike
          CloseLibrary(*BASS_MIDI)
          ;Sleep_(1000)
        *BASS_MIDI_StreamCreateFile = 0
        EndIf
      HadMidiPluginOnce = 0
      CompilerEndIf
    
    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      If *TAGS_Read
        SendToDebugger("TAGS", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
        CloseLibrary(*TAGS)
        *TAGS_Read = 0
        EndIf
      CompilerEndIf
    CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      If *BASS_CD_StreamCreateFile
        SendToDebugger("CD", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
        CloseLibrary(*BASS_CD)
        *BASS_CD_StreamCreateFile = 0
        EndIf
      CompilerEndIf
    SendToDebugger("done!", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_Snd | #ctSSLayer_DbgFlag_Msc_Sub)
    HasPreDone = #False
    EndIf
  MidiCounter = 0
  *Debugger = 0
  ;CloseConsole()
  ;ClearOutputList()
  ;ClearSoundFontList()
  ;Sleep_(1000)
  EndProcedure

ProcedureDLL.i ctSSLayer_DllRelease()
  If *BassDLL
    CloseLibrary(*BassDLL)
    *BassDLL = 0
    WasInited = #False
    EndIf
  ClearOutputList()
  ClearSoundFontList()
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLID
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLIDA
  ProcedureDLL.i ctSSLayer_GetDeviceFromSSLIDA(*SSLID)
  CompilerElse
  Procedure.i ctSSLayer_GetDeviceFromSSLIDA(*SSLID)
  CompilerEndIf
    Define.i Result
    Define.s xChar1

    Result = -1
    If *SSLID
      xChar1 = LCase(PeekS(*SSLID))
      If Left(xChar1, 5) = "bass_"
        Result = Val(Mid(xChar1, 6))
        If Result < 0 Or Result >= OutPutListCount
          Result = -1
          EndIf
        EndIf
      EndIf
    ProcedureReturn Result

    CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLIDA = 1
    EndProcedure
    CompilerElse
    EndProcedure
    CompilerEndIf
  CompilerEndIf

XIncludeFile "ctSSLayer_Common_GetDeviceFromSSLIDW.pb" ;- ctSSLayer_GetDeviceFromSSLIDW

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLID
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLIDA
  ProcedureDLL.i ctSSLayer_GetDeviceSSLIDA(DeviceID.i)
  CompilerElse
  Procedure.i ctSSLayer_GetDeviceSSLIDA(DeviceID.i)
  CompilerEndIf
    
    If DeviceID >= 0 And DeviceID < OutPutListCount
      InfoString = "bass_" + Str(DeviceID)
      ProcedureReturn @InfoString
      EndIf

  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLIDA
    EndProcedure
  CompilerElse
    EndProcedure
  CompilerEndIf
  CompilerEndIf

XIncludeFile "ctSSLayer_Common_GetDeviceSSLIDW.pb" ;- ctSSLayer_GetDeviceSSLIDW

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameA
  ProcedureDLL.i ctSSLayer_GetDeviceNameA(DeviceID, *Flags)
    If DeviceID >= 0 And DeviceID < OutPutListCount
      If *Flags: PokeL(*Flags, $100): EndIf
      CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
        If OutPutList(DeviceID) = 0
          ProcedureReturn 0
          EndIf
        InfoString = PeekS(OutPutList(DeviceID),-1,#PB_Unicode)
        CompilerElse
        InfoString = OutPutList(DeviceID)
        CompilerEndIf
      ProcedureReturn @InfoString
      EndIf
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
  ProcedureDLL.i ctSSLayer_GetDeviceNameW(DeviceID, *Flags)
    If DeviceID >= 0 And DeviceID < OutPutListCount
      If *Flags: PokeL(*Flags, $100): EndIf
      ProcedureReturn OutPutList(DeviceID)
      EndIf
    ProcedureReturn 0
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_SoundFontGetSize(FontID.i, *ptrQuad)
  If *ptrQuad And FontID >= 0 And FontID < SoundFontListCount
    PokeQ(*ptrQuad, SoundFontSize(FontID))
    ProcedureReturn #True
    EndIf
  ProcedureReturn #False
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetCaptionA(FontID.i)
  Define.i xLong1

  If FontID >= 0 And FontID < SoundFontListCount
    If SoundFontList(FontID)
      InfoString = PeekS(SoundFontList(FontID) + SoundFontCaps(FontID),-1,#PB_Unicode)
      xLong1 = Len(InfoString)
      If xLong1 > 4
        InfoString = Left(InfoString, xLong1 - 4)
        Else
        InfoString = ""
        EndIf
      ProcedureReturn @InfoString
      EndIf
    EndIf
  ProcedureReturn 0
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetCaptionW(FontID.i)
  Define.i xResult
  Define.i xLong1

  If FontID >= 0 And FontID < SoundFontListCount
    If SoundFontList(FontID)
      xLong1 = lstrlenW(SoundFontList(FontID) + SoundFontCaps(FontID)) - 4
;Debug "#1:" + PeekS(SoundFontList(FontID), -1, #PB_Unicode)
;Debug "#2:" + PeekS(SoundFontList(FontID) + SoundFontCaps(FontID), -1, #PB_Unicode)
;Debug "#3:" + Str(xLong1)
      If xLong1 > 0
        If InfoStringW
          FreeMemory(InfoStringW)
          EndIf
        InfoStringW = AllocateMemory((xLong1 + 1) << 1)
        If InfoStringW
          xResult = InfoStringW
          RtlMoveMemory_(InfoStringW, SoundFontList(FontID) + SoundFontCaps(FontID), xLong1 << 1)
          PokeW(InfoStringW + (xLong1 << 1), 0)
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetFilenameA(FontID.i)
  If FontID >= 0 And FontID < SoundFontListCount
    If SoundFontList(FontID)
      InfoString = PeekS(SoundFontList(FontID),-1,#PB_Unicode)
      ProcedureReturn @InfoString
      EndIf
    EndIf
  ProcedureReturn 0
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetFilenameW(FontID.i)
  If FontID >= 0 And FontID < SoundFontListCount
    If SoundFontList(FontID)
      ProcedureReturn SoundFontList(FontID)
      EndIf
    EndIf
  ProcedureReturn 0
  EndProcedure

;ProcedureDLL.i ctSSLayer_GetSoundFontCaptionA(FontID.i)
;  EndProcedure

;ProcedureDLL.i ctSSLayer_GetSoundFontCaptionW(FontID.i)
;  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA Or #ctSSLayer_CompiledFeature_GetInfoStringW
  IncludeFile "ctSSLayer_Common_VerQueryValue.pb"
  ;IncludeFile "ctSSLayer_Common_GetFileVersionEx.pb"
  
  Procedure.s GetCopyRightFromFile(Filename.s)
    ;Define.s Result
    Define.s xChar1
    Define.s xChar2
    Define *hMem
    
    *hMem = GetFileVersionInfo(Filename)
    If *hMem
  ;    xChar1 = Trim(GetFileVersionFieldEx(Filename, #GetFileVersionField_CompanyName))
      ;XDebug ("Comments", *hMem, #GetFileVersionField_Comments)
      ;XDebug ("CompanyName", *hMem, #GetFileVersionField_CompanyName)
      ;XDebug ("FileDesc", *hMem, #GetFileVersionField_FileDesc)
      ;XDebug ("InternalName", *hMem, #GetFileVersionField_InternalName)
      ;XDebug ("LegalCopyright", *hMem, #GetFileVersionField_LegalCopyright)
      
      xChar1 = Trim(VerQueryValue(*hMem, #GetFileVersionField_LegalCopyright))
      If Left(xChar1, 10) = "Copyright "
        xChar1 = LTrim(Mid(xChar1, 11))
        EndIf
      If Left(xChar1, 1) = Chr(169)
        xChar1 = LTrim(Mid(xChar1, 2))
        EndIf
      If Right(xChar1, 20) = "Un4seen Developments"
        xChar1 = xChar1 + " Ltd. All rights reserved."
        EndIf
      If Right(xChar1, 8) = "MaresWEB"
        xChar1 = xChar1 + " (http://www.maresweb.de). All rights reserved"
        EndIf
      If Len(xChar1) < 12
        xChar2 = Trim(VerQueryValue(*hMem, #GetFileVersionField_CompanyName))
        If xChar2
          If xChar2 = "Un4seen Developments"
            xChar2 = xChar2 + " Ltd. All rights reserved."
            EndIf
          If xChar2 = "MaresWEB"
            xChar2 = xChar2 + " (http://www.maresweb.de). All rights reserved"
            EndIf
          If xChar1
            xChar1 = xChar1 + ", " + xChar2
            Else
            xChar1 = xChar2
            EndIf
          EndIf
        EndIf
  
      If xChar1
        ;Debug Caption + " / " + Mid(Filename, Len(Filename) - FindString(ReverseString(Filename), "\", 1) + 2) + ": " + xChar1
        xChar1 = "Copyright " + xChar1
        EndIf
      
      xChar2 = Trim(VerQueryValue(*hMem, #GetFileVersionField_FileVersion))
      If Left(xChar1, 8) = "Version "
        xChar2 = LTrim(Mid(xChar2, 9))
        EndIf
      ;If Not xChar2
      ;  Define.i xLong1
      ;  Define.i xLong2 = GetFileVersionEx(Filename, @xLong1)
      ;  Debug Hex(xLong2) + " / " + Hex(xLong1)
      ;  EndIf
      If xChar2
        If xChar1
          xChar1 = "Version " + xChar2 + "; " + xChar1
          Else
          xChar1 = "Version " + xChar2
          EndIf
        EndIf
      
      ;If xChar1
       ; ;Debug Caption + " / " + Mid(Filename, Len(Filename) - FindString(ReverseString(Filename), "\", 1) + 2) + ": " + xChar1
       ; ;Debug xChar1
       ; ;Else
       ; ;Debug "********* Fail Copyright *****************************" + Mid(Filename, Len(Filename) - FindString(ReverseString(Filename), "\", 1) + 2)
       ; EndIf
  
      ;XDebug ("LegalTrademarks", *hMem, #GetFileVersionField_LegalTrademarks)
      ;XDebug ("OriginalFilename", *hMem, #GetFileVersionField_OriginalFilename)
      ;XDebug ("PrivateBuild", *hMem, #GetFileVersionField_PrivateBuild)
      ;XDebug ("ProductName", *hMem, #GetFileVersionField_ProductName)
  ;  XDebug ("ProductVersion", *hMem, #GetFileVersionField_ProductVersion)
      ;XDebug ("SpecialBuild", *hMem, #GetFileVersionField_SpecialBuild)
      
      FreeFileVersionInfo(*hMem)
      ProcedureReturn xChar1
      EndIf
    EndProcedure
  
  CompilerIf 0
    Procedure.s GetCopyRightFromBASS()
    Define.s xChar1
    Define.s xChar2
    Define *hMem
    
    *hMem = GetFileVersionInfo("bass.dll")
    If *hMem
      xChar1 = Trim(VerQueryValue(*hMem, #GetFileVersionField_LegalCopyright))
      If Left(xChar1, 10) = "Copyright "
        xChar1 = LTrim(Mid(xChar1, 11))
        EndIf
      If Left(xChar1, 1) = Chr(169)
        xChar1 = LTrim(Mid(xChar1, 2))
        EndIf
      If Right(xChar1, 20) = "Un4seen Developments"
        xChar1 = xChar1 + " Ltd. All rights reserved."
        EndIf
      If Len(xChar1) < 12
        xChar2 = Trim(VerQueryValue(*hMem, #GetFileVersionField_CompanyName))
        If xChar2
          If xChar2 = "Un4seen Developments"
            xChar2 = xChar2 + " Ltd. All rights reserved."
            EndIf
          If xChar1
            xChar1 = xChar1 + ", " + xChar2
            Else
            xChar1 = xChar2
            EndIf
          EndIf
        EndIf
  
      If xChar1
        xChar1 = "Copyright " + xChar1
        EndIf
      
      FreeFileVersionInfo(*hMem)
      ProcedureReturn xChar1
      EndIf
    EndProcedure
  CompilerEndIf
  
  Procedure GetPluginCPI(Caption.s, *hDLL, Filename.s, ExtraInfo.s)
    ;Global HasPI
    If *hDLL
      Filename = GetCopyRightFromFile(Filename)
      If Filename
        Filename = " " + Filename
        EndIf
      InfoString = InfoString + Chr(13) + Chr(10) + Caption + Filename + ExtraInfo
      ;HasPI = 1
      ;Debug Caption + Filename + ExtraInfo
      EndIf
    EndProcedure
  
  
  
  Procedure GetBassVersionStr()
    Define *hMem
    
    *hMem = GetFileVersionInfo("bass.dll")
    If *hMem
      InfoString = Trim(VerQueryValue(*hMem, #GetFileVersionField_FileVersion))
      If Left(InfoString, 8) = "Version "
        InfoString = LTrim(Mid(InfoString, 9))
        EndIf
      FreeFileVersionInfo(*hMem)
      EndIf
    EndProcedure
  
  
  
  
  
  
  
  
CompilerIf #BASS_UseMidi
  Procedure GetSoundFontInfo()
    Define.BASS_MIDI_FONTINFO xType1
    Define.s xChar1
    
    If *BASS_MIDI
    ;Debug 2
      If CallFunction(*BASS_MIDI, "BASS_MIDI_FontGetInfo", hCBSoundFontFile, @xType1)
        If (xType1\name)
          If PeekB(xType1\name)
            xChar1 = Trim(PeekS(xType1\name))
            If xChar1
              InfoString = InfoString + Chr(13) + Chr(10) + "SoundFont: " + xChar1
              If (xType1\copyright)
                xChar1 = Trim(PeekS(xType1\copyright))
                If xChar1
                  InfoString = InfoString + "; Copyright: " + xChar1
                  EndIf
                EndIf
              EndIf
            EndIf
          EndIf
;        Debug "name:" + PeekS(xType1\name)
;        Debug "copy:" + PeekS(xType1\copyright)
;        Debug "comm:" + PeekS(xType1\comment)
        ;If IsUnicode
        ;  Debug "file:" + PeekS(*SoundFontFile, -1,#PB_Unicode)
        ;  Else
        ;  Debug "file:" + PeekS(*SoundFontFile, -1,#PB_Ascii)
        ;  EndIf
        EndIf
      EndIf 
    EndProcedure
  CompilerEndIf
  
CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA
ProcedureDLL.i ctSSLayer_GetInfoStringA(Index.i)
CompilerElse
Procedure.i ctSSLayer_GetInfoStringA(Index.i)
CompilerEndIf

  Select Index
    Case 0 ; ShortName
      InfoString = "BASS"
    Case 1 ; FullName
      InfoString = "BASS Audio library"
    Case 2 ; DllName
      InfoString = "bass.dll"
;    Case 3 ; Short Version byfix
;      InfoString = "bass"
    Case 4 ; Unique dll/versions string
      ;InfoString = "bass_" + PeekS(ctSSLayer_GetInfoStringA(30))
      InfoString = "bass_" + Str(VersionID >> 16) + "." + Right("0" + Str(VersionID & $ffff), 2)
    Case $5 ; Full copyright, info etc
      ;InfoString = GetCopyRightFromBASS()
      InfoString = ""
      If *BassDLL
        GetPluginCPI("BASS Audio library", *BassDLL, "bass.dll", "")
        ElseIf OSToNew
        GetPluginCPI("BASS Audio library", 1, "bass.dll", "")
        Else
        InfoString = Chr(13) + Chr(10) + "BASS Audio library"
        EndIf
      InfoString = Mid(InfoString, 3)
    Case $A ; Full plugin copyright info
      InfoString = ""
      GetPluginCPI("WMA plugin", *BASS_WMA_StreamCreateFile, "basswma.dll", "")
      CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
        GetPluginCPI("CD plugin", *BASS_CD_StreamCreateFile, "basscd.dll", "")
        CompilerEndIf
      GetPluginCPI("FLAC plugin", *BASS_FLAC_StreamCreateFile, "bassflac.dll", "")
      CompilerIf #BASS_UseMidi
        GetPluginCPI("MIDI plugin", *BASS_MIDI_StreamCreateFile, "bassmidi.dll", "")
        CompilerEndIf
      GetPluginCPI("WV plugin", *BASS_WV_StreamCreateFile, "basswv.dll", "")
      GetPluginCPI("OPUS plugin", *BASS_OPUS_StreamCreateFile, "bassopus.dll", "")
      GetPluginCPI("MPC plugin", *BASS_MPC_StreamCreateFile, "bass_mpc.dll", "; Portions  2006, The Musepack Development Team. All rights reserved.")
      GetPluginCPI("AC3 plugin", *BASS_AC3_StreamCreateFile, "bass_ac3.dll", "; Portions  2006 Dolby Laboratories, Inc. All rights reserved.")
      GetPluginCPI("AAC plugin", *BASS_AAC_StreamCreateFile, "bass_aac.dll", "; Portions  2006, M. Bakker, Nero AG. All rights reserved.")
      GetPluginCPI("APE plugin", *BASS_APE_StreamCreateFile, "bass_ape.dll", "; Portions  2000-2006, Matthew T. Ashland. All rights reserved.")
      CompilerIf #ctSSLayer_CompiledFeature_ReadTags
        ;GetTagPluginInfo()
        GetPluginCPI("TAGS - Yet Another Tags Reading Library", *TAGS_Read, "tags.dll", "; Written by Wraith, 2k5-2k6; Contributions by Ian Luck And Dylan Fitterer; Delphi header And sample by Chris Troesken; Public domain. No warranty.")
    ;InfoString = InfoString + Chr(13) + Chr(10) + "TAGS - Yet Another Tags Reading Library" + xChar1 + "; Written by Wraith, 2k5-2k6; Contributions by Ian Luck And Dylan Fitterer; Delphi header And sample by Chris Troesken; Public domain. No warranty."
        CompilerEndIf
      CompilerIf #BASS_UseMidi
        GetSoundFontInfo()
        CompilerEndIf
      InfoString = Mid(InfoString, 3)
    Case $B; trademarks
      InfoString = "SoundFont is a registered trademark of Creative Technology Ltd in the United States and/or other countries."
    Case $10 ; StreamsAll
      InfoString = "ogg;mp1,mp2,mp3;"
      If *BASS_MPC_StreamCreateFile:  InfoString + "mpc;":  EndIf
      If *BASS_WMA_StreamCreateFile:  InfoString + "wma;":  EndIf
     ; If *BASS_AAC_StreamCreateFile
     ;   If*BASS_MP4_StreamCreateFile
     ;     InfoString + "aac,mp4;"
      ;    Else
      ;    InfoString + "aac;"
      ;    EndIf
      ;  ElseIf *BASS_MP4_StreamCreateFile
      ;  InfoString + "mp4;"
      ;  EndIf
      If *BASS_AAC_StreamCreateFile:  InfoString + "aac;":  EndIf
      If *BASS_AC3_StreamCreateFile:  InfoString + "ac3;":  EndIf
      If *BASS_APE_StreamCreateFile:  InfoString + "ape;":  EndIf
      If *BASS_FLAC_StreamCreateFile: InfoString + "flac;": EndIf
      If *BASS_WV_StreamCreateFile:   InfoString + "wv;":   EndIf
      If *BASS_OPUS_StreamCreateFile: InfoString + "opus;": EndIf
      InfoString + "wav;"
    Case $11 ; TrackerAllbutMidi
      InfoString = "mod,it,xm,s3m;mtm;mo3;umx;"
    Case $12 ; Midi
      CompilerIf #BASS_UseMidi
        If *BASS_MIDI_StreamCreateFile: InfoString = "mid,midi;": EndIf
        CompilerEndIf
      ;InfoString = "mid,midi;rmi,sgt;"
    Case $19 ; AllDef
      InfoString = "ogg;mp2,mp3;"
      If *BASS_MPC_StreamCreateFile:  InfoString + "mpc;":  EndIf
      If *BASS_FLAC_StreamCreateFile: InfoString + "flac;": EndIf
    Case $30
      ;Debug Hex(VersionID & $ffff0000)
      ;Debug Hex((VersionID & $ffff0000) >> 16)
      ;Define xLong1.i
      ;xLong1 = Int (VersionID / 
      ;InfoString = Str(VersionID >> 16) + "." + Right("0" + Str(VersionID & $ffff), 2)
      GetBassVersionStr()  
    Case $31 ; required dll files; seperate with ;!
      InfoString = "bass.dll;msvcrt.dll"
    Case $40 ; homepage URL
      InfoString = "http://www.un4seen.com"
    Default
      InfoString = ""
      ProcedureReturn 0
    EndSelect
  
  
  
  ProcedureReturn @InfoString
CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA ; for PB IDE folding feature
  EndProcedure                                       ; for PB IDE folding feature
CompilerElse                                         ; for PB IDE folding feature
  EndProcedure                                       ; for PB IDE folding feature
CompilerEndIf                                        ; for PB IDE folding feature
  CompilerEndIf

CompilerIf 0                                         ; for enlisting in current project, real procedure in common file
  ProcedureDLL.i ctSSLayer_GetInfoStringW(Index.i)   ; for enlisting in current project, real procedure in common file
    EndProcedure                                     ; for enlisting in current project, real procedure in common file
  CompilerEndIf                                      ; for enlisting in current project, real procedure in common file
XIncludeFile "ctSSLayer_Common_GetInfoStringW.pb"

ProcedureDLL.i ctSSLayer_GetPosition(*SongPointer.tSong)
  Define.i xResult
  CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Define.q xLen
    Define.q xBuf
    CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_InetStreams
  #BASS_FILEPOS_END = 2
  #BASS_FILEPOS_BUFFER = 5
  #BASS_CONFIG_NET_BUFFER = 12

  If *SongPointer\Mode = #BassLayer_ModeINet
    If CallFunctionFast(*BASS_ChannelIsActive, *SongPointer\Pointer) = #BASS_ACTIVE_STOPPED
      xResult = 0
      Else
      If VersionID > $20003
        xLen = BASS_StreamGetFilePosition24(*SongPointer\Pointer, #BASS_FILEPOS_END)
        If xLen
          xBuf = BASS_StreamGetFilePosition24(*SongPointer\Pointer, #BASS_FILEPOS_BUFFER)
          xResult = (xBuf * 100) / xLen
          EndIf
        Else
        xLen = CallFunctionFast(*BASS_StreamGetFilePosition23, *SongPointer\Pointer, #BASS_FILEPOS_END)
        If xLen
          xBuf = CallFunctionFast(*BASS_StreamGetFilePosition23, *SongPointer\Pointer, #BASS_FILEPOS_BUFFER)
          xResult = (xBuf * 100) / xLen
          EndIf
        EndIf
      EndIf
    ElseIf *SongPointer\Mode
CompilerElse
  If *SongPointer\Mode
CompilerEndIf
    Select CallFunctionFast(*BASS_ChannelIsActive, *SongPointer\Pointer)
      Case #BASS_ACTIVE_STALLED
        xResult = *SongPointer\Size
      Case #BASS_ACTIVE_STOPPED
        xResult = 0
      Default
          If VersionID > $20003
            xResult = (BASS_ChannelBytes2Seconds24(*SongPointer\Pointer, BASS_ChannelGetPosition24(*SongPointer\Pointer, #BASS_POS_BYTE)) * 1000)
            Else
            xResult = (BASS_ChannelBytes2Seconds23(*SongPointer\Pointer, BASS_ChannelGetPosition23(*SongPointer\Pointer)) * 1000)
            EndIf
      EndSelect
    EndIf
  ProcedureReturn xResult
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  XIncludeFile "ctSSLayer_Common_MaxF.pb"

  ProcedureDLL ctSSLayer_GetSpectrum(*xSingleA1, ArraySize.i, *SongPointer.tSong, Stereo.i)
    Static xLong1.i
    Static xLong2.i
    Static xLong4.i
    Static xSingle1.f
    Static xSingle2.f
  
    #xWGS_GetWidth = 1024
    #xWGS_GetWidth_ArrayLIDX = #xWGS_GetWidth * 2 - 1
    Static Dim xSingleA2.f(#xWGS_GetWidth_ArrayLIDX)
    Static Dim xSingleA3.f(#xWGS_GetWidth_ArrayLIDX)
    Static Dim xSingleA4.f(#xWGS_GetWidth_ArrayLIDX)
  
    If *SongPointer
      If CallFunctionFast(*BASS_ChannelGetData, *SongPointer\Pointer, @xSingleA2(0), $80000012) = -1
        If Stereo = 3
          RtlZeroMemory_(*xSingleA1, ArraySize * 8)
          Else
          RtlZeroMemory_(*xSingleA1, ArraySize * 4)
          EndIf
        Else
        If ArraySize > #xWGS_GetWidth: ArraySize = #xWGS_GetWidth: EndIf
        For xLong1 = 0 To ArraySize - 1
          xLong2 = xLong1 * #xWGS_GetWidth / ArraySize
          xSingle1 = xSingleA2(xLong2)
          xSingle2 = xSingleA3(xLong2)
          For xLong4 = xLong2 + 1 To (xLong1 + 1) * #xWGS_GetWidth / ArraySize - 1
            xSingle1 = MaxF(xSingle1, xSingleA2(xLong4))
            xSingle2 = MaxF(xSingle2, xSingleA3(xLong4))
            Next
          xSingleA2(xLong1) = xSingle1 * 1.5
          xSingleA3(xLong1) = xSingle2 * 1.5
          xSingleA4(xLong1) = MaxF(xSingle1, xSingle2) * 1.5
          Next
        Select Stereo
          Case 0
            CopyMemory(@xSingleA4(0), *xSingleA1, ArraySize * 4)
          Case 1
            CopyMemory(@xSingleA2(0), *xSingleA1, ArraySize * 4)
          Case 2
            CopyMemory(@xSingleA3(0), *xSingleA1, ArraySize * 4)
          Case 3
            CopyMemory(@xSingleA2(0), *xSingleA1, ArraySize * 4)
            CopyMemory(@xSingleA3(0), *xSingleA1 + ArraySize * 4, ArraySize * 4)
          EndSelect
        EndIf  
      Else
      If Stereo = 3
        RtlZeroMemory_(*xSingleA1, ArraySize * 8)
        Else
        RtlZeroMemory_(*xSingleA1, ArraySize * 4)
        EndIf
      EndIf
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_Init(OutputDeviceID, hWnd.i, UseCDDA.i, UseJitterCorrection.i)
  If WasInited And *BassDLL = 0
    ctSSLayer_PreInit(hWnd)
    Else
    GetPreFuncs()
    EndIf

  If OutputDeviceID >= 0 And OutputDeviceID < OutPutListCount
    CallFunction(*BassDLL, "BASS_SetDevice", (OutputDeviceID & $FF) + 1)
;PrintN("Initing 1: " + Str(*BassDLL))
    If CallFunction(*BassDLL, "BASS_Init", (OutputDeviceID & $FF) + 1, 44001, 0, hWnd, 0)
;PrintN("Initing 2")
      GetFuncs()
      xSystem = 1
      ProcedureReturn 1
      EndIf
    EndIf
  EndProcedure


CompilerIf 0 ;#ctSSLayer_CompiledFeature_CD_AndOr_CDDA
  Procedure.i DriveIDfromLetter(DriveLetter.s)
    Define.i xLong1
    Define.i DriveIDfromLetter
  
    xLong1 = Asc(UCase(Left(DriveLetter, 1))) - 65
    Repeat
      ;Debug *BASS_CD_GetDriveLetter
      ;Debug "For " + Str(DriveIDfromLetter) + ": " + Str(CallFunctionFast(*BASS_CD_GetDriveLetter, DriveIDfromLetter))
      ;Debug "Want: " + Str(xLong1)
      Select CallFunctionFast(*BASS_CD_GetDriveLetter / *BASS_CD_GetInfo, DriveIDfromLetter)
      ;Select CallFunctionFast(*BASS_CD_GetDriveLetter, @xLong1)
        Case xLong1
          Break
        Case -1
          DriveIDfromLetter = -1
          Break
        Default
          DriveIDfromLetter = DriveIDfromLetter + 1
        EndSelect
      ForEver
    ProcedureReturn DriveIDfromLetter
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_ReadTags
  Procedure.f GetQualityMultiByFilename(Filename.s)
    Define Result.f
  
    Select LCase(GetExtensionPart(Filename))
      Case "wav"
        Result = 0.1
      Case "flac"
        Result = 0.2
      Default
        Result = 1
      EndSelect
    ProcedureReturn Result
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_IsStreamMIDI(*SongPointer.tSong)
  CompilerIf #BASS_UseMidi
    If *SongPointer\Mode = #BassLayer_ModeMIDI
      ProcedureReturn #True
      EndIf
    CompilerEndIf
    ProcedureReturn #False
  EndProcedure

;mode.i, *Filename, Flags.i, UnicodeFlag.i, *SongPointer
Procedure.i ctSSLayer_LoadSongReal(*Params.RealLoaderParams) ;, TrackID.i)
  Define.i xLong1
  Define.i FlagsNew
  Define *SongPointer.tSong
  Define.s FilenameAnsi
  Define.ProtoBASSCreateFile24 ProtoLoader
  CompilerIf #BASS_UseMidi
    Define.ProtoBASSCreateFileMidi24 ProtoLoaderMidi
    CompilerEndIf

  If DebuggerThreadSave Or Not *Params\IsThread
    SendToDebugger("LoadSong: Real/thread enter", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Lay)
    EndIf

  EnterCriticalThreadState()

  If *Params\UnicodeFlag
    FilenameAnsi = PeekS(*Params\Filename, -1, #PB_Unicode)
    xLong1 = GetFileAttributesW(*Params\Filename)
    Else
    FilenameAnsi = PeekS(*Params\Filename)
    xLong1 = GetFileAttributes_(FilenameAnsi)
    EndIf

  *SongPointer = *Params\SongPointer

  If *SongPointer
    If (xLong1 & $ffffffff) = $ffffffff
      *SongPointer\ThreadState = -1
      Else
      Select *Params\Mode
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
        Case #ctSSLayer_MusicTypeInetStream
          If *BASS_StreamCreateURL
            *SongPointer\Pointer = CallFunctionFast(*BASS_StreamCreateURL, @FilenameAnsi, 0, FlagsNew, 0, 0)
            *SongPointer\Mode = #BassLayer_ModeINet
            EndIf
CompilerEndIf
        Case #ctSSLayer_MusicTypeStream
          Select LCase(GetExtensionPart(FileNameAnsi))
            Case "mpc"
              ProtoLoader = *BASS_MPC_StreamCreateFile ; unicode: used in .bas!
              *SongPointer\Mode = #BassLayer_ModeMPC
            Case "wma"
              ProtoLoader = *BASS_WMA_StreamCreateFile ; unicode: yes
              *SongPointer\Mode = #BassLayer_ModeWMA
            Case "flac"
              ProtoLoader = *BASS_FLAC_StreamCreateFile ; unicode: yes
              *SongPointer\Mode = #BassLayer_ModeFLAC
            Case "aac"
              ProtoLoader = *BASS_AAC_StreamCreateFile ; unicode: used in .bas!
              *SongPointer\Mode = #BassLayer_ModeAAC
              FlagsNew = $20000
            ;Case "mp4"
            ;  ProtoLoader = *BASS_MP4_StreamCreateFile
            ;  FlagsNew = $20000)
            ;  *SongPointer\Mode = #BassLayer_ModeMP4
            Case "ape"
              ProtoLoader = *BASS_APE_StreamCreateFile ; unicode: used in .bas!
              *SongPointer\Mode = #BassLayer_ModeAPE
            Case "ac3"
              ProtoLoader = *BASS_AC3_StreamCreateFile ; unicode: used in .bas!
              *SongPointer\Mode = #BassLayer_ModeAC3
              FlagsNew = $200
            Case "wv"
              ProtoLoader = *BASS_WV_StreamCreateFile ; unicode: yes
              *SongPointer\Mode = #BassLayer_ModeWV
            Case "opus"
              ProtoLoader = *BASS_OPUS_StreamCreateFile ; unicode: yes
              *SongPointer\Mode = #BassLayer_ModeOPUS
            Default
              If (*Params\Flags & 1)
                FlagsNew = $20000
                EndIf
              ProtoLoader = *BASS_StreamCreateFile
              *SongPointer\Mode = #BassLayer_ModeStream
            EndSelect
          If *SongPointer\Mode And ProtoLoader
            If VersionID > $20003
              *SongPointer\Pointer = ProtoLoader.ProtoBASSCreateFile24(0, *Params\FileName, 0, 0, FlagsNew | *Params\UnicodeFlag)
              Else
              *SongPointer\Pointer = CallFunctionFast(*BASS_StreamCreateFile, 0, @FileNameAnsi, 0, 0, FlagsNew)
              EndIf
            EndIf
        Case #ctSSLayer_MusicTypeTracker
          Select LCase(GetExtensionPart(FileNameAnsi))
CompilerIf #BASS_UseMidi
            Case "mid", "midi"
              *SongPointer\Mode = #BassLayer_ModeMIDI
              If *BASS_MIDI_StreamCreateFile
                If VersionID > $20003
                  ProtoLoaderMidi = *BASS_MIDI_StreamCreateFile
                  CompilerIf #TestIT = 3
                    OpenConsole()
                    Print("Attach debugger and press any key")
                    Repeat
                      Until Inkey()
                    Print("continuing...")
                    CompilerEndIf
                  *SongPointer\Pointer = ProtoLoaderMidi.ProtoBASSCreateFileMidi24(0, *Params\FileName, 0, 0, FlagsNew | *Params\UnicodeFlag, 44100)
                  Else
                  *SongPointer\Pointer = CallFunctionFast(*BASS_MIDI_StreamCreateFile, 0, @FileNameAnsi, 0, 0, FlagsNew, 44100)
                  EndIf
                EndIf
CompilerEndIf
            Default
              If VersionID > $20003
                *SongPointer\Pointer = BASS_MusicLoad24(0, *Params\FileName, 0, 0, $28000 | *Params\UnicodeFlag, 0)
                Else
                *SongPointer\Pointer = CallFunctionFast(*BASS_MusicLoad23, 0, @FileNameAnsi, 0, 0, $28000, 0)
                EndIf
              *SongPointer\Mode = #BassLayer_ModeTracker
            EndSelect
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
        Case #ctSSLayer_MusicTypeCDAudio
          ;Debug "x"
          ;*SongPointer\Pointer = CallFunctionFast(*BASS_CD_StreamCreateFile, DriveIDfromLetter(FileNameAnsi), Val(GetTrackNumber(FileNameAnsi)) - 1, 0)
          If VersionID > $20003
            ; No need for unicode for CD access!
            *SongPointer\Pointer = CallFunctionFast(*BASS_CD_StreamCreateFile, @FileNameAnsi, 0)
            Else
            *SongPointer\Pointer = CallFunctionFast(*BASS_CD_StreamCreateFile, @FileNameAnsi)  
            EndIf
          ;Debug *SongPointer\Pointer
          ;Debug "DriveID: " + Str(DriveIDfromLetter(FileNameAnsi))
          ;Debug "Track: " + Str(Val(GetTrackNumber(FileNameAnsi)) - 1)
          *SongPointer\Mode = #BassLayer_ModeCDDA
CompilerEndIf
        EndSelect
  
      If *SongPointer\Pointer
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
        If *SongPointer\mode = #BassLayer_ModeINet
          ;*SongPointer\Format_QualityMulti = 1
          *SongPointer\Size = 3600000 ; 1h ; 300000 ;5 mins!
          Else
CompilerEndIf
          If *Params\UnicodeFlag
            xLong1 = CreateFileW(*Params\FileName, #BASS_UNICODE, 1, #Null, 3, $20, 0)
            Else
            xLong1 = CreateFile_(*Params\FileName, #BASS_UNICODE, 1, #Null, 3, $20, 0)
            EndIf
          If xLong1
            *SongPointer\FileSize = GetFileSize_(xLong1, #Null)
            If *SongPointer\FileSize = -1
              *SongPointer\FileSize = 0
              EndIf
            CloseHandle_(xLong1)
            EndIf
          If VersionID > $20003
            *SongPointer\Size = (BASS_ChannelBytes2Seconds24(*SongPointer\Pointer, BASS_ChannelGetLength24(*SongPointer\Pointer, #BASS_POS_BYTE))) * 1000
            Else
            *SongPointer\Size = (BASS_ChannelBytes2Seconds23(*SongPointer\Pointer, BASS_ChannelGetLength23(*SongPointer\Pointer))) * 1000
            EndIf
          CompilerIf #ctSSLayer_CompiledFeature_ReadTags
            *SongPointer\Format_QualityMulti = GetQualityMultiByFilename(FileNameAnsi)
            CompilerEndIf
          ;xLong1 = Len(FileNameAnsi)
          If *SongPointer\Mode = #BassLayer_ModeMIDI
            MidiCounter + 1
            EndIf
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
          EndIf
CompilerEndIf

        *SongPointer\ThreadState = 1
        Else
        ;*SongPointer\Mode = 0
        *SongPointer\ThreadState = -1
        EndIf
      EndIf
    EndIf
  FreeMemory(*Params)
  If DebuggerThreadSave Or Not *Params\IsThread
    SendToDebugger("LoadSong: Real/thread leave", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Lay)
    EndIf
  LeaveCriticalThreadState()
  EndProcedure

Procedure.i ctSSLayer_LoadSong(mode.i, *Filename, Flags.i, UnicodeFlag.i) ;, TrackID.i)
  Define *Params.RealLoaderParams
  Define *SongPointer.tSong

  *SongPointer = AllocateMemory(SizeOf(tSong))
  If *SongPointer
    *Params = AllocateMemory(SizeOf(RealLoaderParams))
    If *Params
      *Params\mode = mode
      If UnicodeFlag
        *Params\UnicodeFlag = UnicodeFlag
        *Params\Filename = LocalAllocStringWFromW(*Filename)
        Else
        *Params\Filename = LocalAllocStringAFromA(*Filename)
        EndIf
      *Params\Flags = Flags
      *Params\SongPointer = *SongPointer
      If Flags & 2 ;And Not Mode = #ctSSLayer_MusicTypeTracker
        ;*SongPointer\ThreadState = 0
        *Params\IsThread = #True
        SendToDebugger("LoadSong: Multithreaded", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Lay)
        CreateThread(@ctSSLayer_LoadSongReal(), *Params)
        Else
        SendToDebugger("LoadSong: Singlethreaded", #ctSSLayer_DbgFlag_Grp_None | #ctSSLayer_DbgFlag_Lvl_HiP | #ctSSLayer_DbgFlag_Lvl_Lay)
        ctSSLayer_LoadSongReal(*Params)
        EndIf
      EndIf
    If (Flags & 2) Or (*SongPointer\ThreadState = 1)
      ProcedureReturn *SongPointer
      EndIf
    FreeMemory(*SongPointer)
    EndIf
  ProcedureReturn 0
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
  ProcedureDLL.i ctSSLayer_LoadSongA(mode.i, *Filename, Flags.i) ;, FullMode.s,, TrackID.i)
    ProcedureReturn ctSSLayer_LoadSong(mode, *Filename, Flags, 0)
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
  ProcedureDLL.i ctSSLayer_LoadSongW(mode.i, *Filename, Flags.i) ;, FullMode.s,, TrackID.i)
    ProcedureReturn ctSSLayer_LoadSong(mode, *Filename, Flags, #BASS_UNICODE)
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_LoadSongFinished(*SongPointer.tSong)
  ProcedureReturn *SongPointer\ThreadState
  EndProcedure

ProcedureDLL ctSSLayer_LoadSongAbort(*SongPointer.tSong)
  Select *SongPointer\Mode
    Case 0, #BassLayer_ModeCDDA ; none / cd
    Case #BassLayer_ModeTracker ; tracker
      CallFunctionFast(*BASS_MusicFree, *SongPointer\Pointer)
    Default
      CallFunctionFast(*BASS_StreamFree, *SongPointer\Pointer)
    EndSelect
  ;*SongPointer\Mode = 0

  If *SongPointer\Mode = #BassLayer_ModeMIDI
    MidiCounter - 1
    EndIf
  FreeMemory(*SongPointer)
  EndProcedure

ProcedureDLL.i ctSSLayer_LoadSongPlay(*SongPointer.tSong, Volume.i, LoopSong.i, Panning.i, Paused.i)
  ;*SongPointer\CurVolume = Volume
;Debug "SetVolPlay"
  If *SongPointer\Mode
    If Paused
      If VersionID > $20003
        BASS_ChannelSetAttribute24(*SongPointer\Pointer, #BASS_ATTRIB_VOL, 0)
        Else
        BASS_ChannelSetAttributes23(*SongPointer\Pointer, -1, 0, -101)
        EndIf
      Else
      If VersionID > $20003
        BASS_ChannelSetAttribute24(*SongPointer\Pointer, #BASS_ATTRIB_VOL, (Volume / 255))
        Else
        BASS_ChannelSetAttributes23(*SongPointer\Pointer, -1, (Volume / 2.55), -101)
        EndIf
      EndIf
    If *SongPointer\Mode = #BassLayer_ModeTracker
      If VersionID > $20003
        BASS_ChannelSetAttribute24(*SongPointer\Pointer, #BASS_ATTRIB_MUSIC_PANSEP, Panning)
        Else
        CallFunctionFast(*BASS_MusicSetAttribute23, *SongPointer\Pointer, 1, Panning) ; * 100)
        EndIf
      EndIf
    CallFunctionFast(*BASS_ChannelPlay, *SongPointer\Pointer, 0)
    If Paused
      CallFunctionFast(*BASS_ChannelPause, *SongPointer\Pointer)
      Else
      *SongPointer\ShouldPlay = 1
      EndIf
    If *SongPointer\Mode = #BassLayer_ModeTracker
      If VersionID > $20003
        BASS_ChannelSetAttribute24(*SongPointer\Pointer, #BASS_ATTRIB_MUSIC_PANSEP, Panning)
        Else
        CallFunctionFast(*BASS_MusicSetAttribute23, *SongPointer\Pointer, 1, Panning) ; * 100)
        EndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      ElseIf *SongPointer\Mode = #BassLayer_ModeCDDA
      IsCDing = 1
CompilerEndIf
      EndIf
    ProcedureReturn 1
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased = 2
  ProcedureDLL.i ctSSLayer_MusicGetPattern(*SongPointer)
    EndProcedure
  
  ProcedureDLL.i ctSSLayer_MusicGetPatterns(*SongPointer)
    EndProcedure
  
  ProcedureDLL.i ctSSLayer_MusicHasFinished(*SongPointer.tSong)
    If *SongPointer\Mode = #BassLayer_ModeTracker
      Select CallFunctionFast(*BASS_ChannelIsActive, *SongPointer\Pointer)
        Case #BASS_ACTIVE_STALLED, #BASS_ACTIVE_STOPPED
          ProcedureReturn 1
        EndSelect
      EndIf
    EndProcedure
  
  ProcedureDLL.i ctSSLayer_MusicTime(*SongPointer)
    EndProcedure
  CompilerEndIf
  
Procedure EnumerateDrv(MainHWnd.i)
  Structure BASS_DEVICEINFO
    *name;
    *driver;
    flags.l
    EndStructure

  Define.i xLong1
  Define.BASS_DEVICEINFO xType1
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
    Define.i xBool1
    CompilerEndIf
  
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
    If VersionID > $20004 Or (VersionID = $20004 And RevisionID > $8ffff)
      xBool1 = CallFunction(*BassDLL, "BASS_SetConfig", 42, 1)
      EndIf    
    CompilerEndIf
  
  If CallFunction(*BassDLL, "BASS_Init", 0, 44001, 0, MainHWnd, 0)
    Repeat
      If VersionID > $20003
        xLong1 = CallFunction(*BassDLL, "BASS_GetDeviceInfo", OutPutListCount + 1, @xType1)
        Else
        xLong1 = CallFunction(*BassDLL, "BASS_GetDeviceDescription", OutPutListCount + 1)
        EndIf
      If xLong1
        ;Debug "Enum: " + PeekS(xLong1)
        If VersionID > $20003
          If xType1\name
            CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
              If xBool1
                OutPutList(OutPutListCount) = LocalAllocStringWFromAnsiOrUTF8Mem(xType1\name, 65001)
                Else
                ;OutPutList(OutPutListCount) = LocalAllocStringWFromW(*Mem)
                OutPutList(OutPutListCount) = LocalAllocStringWFromAnsiOrUTF8Mem(xType1\name, 0)
                EndIf
              CompilerElse
              OutPutList(OutPutListCount) = PeekS(xType1\name)
              CompilerEndIf
            EndIf
          Else
          CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
            OutPutList(OutPutListCount) = LocalAllocStringWFromAnsiOrUTF8Mem(xLong1, 0)
            CompilerElse
            OutPutList(OutPutListCount) = PeekS(xLong1)
            CompilerEndIf
          EndIf
        OutPutListCount + 1
        If OutPutListCount = #OutPutListMax
          Break
          EndIf
        Else
        Break
        EndIf
      ForEver
    CallFunction(*BassDLL, "BASS_Free")
    EndIf
  EndProcedure

XIncludeFile "ctSSLayer_Common_GetWinSysPath.pb"

ProcedureDLL.i ctSSLayer_PreInit(MainHWnd.i)
  Define.i xLong1
  
  OutPutListCount = 0
  xLong1 = GetVersion_()
  If (xLong1 & $80000000) = 0
    IsUnicode = 1
    EndIf
  Define.i Major = (xLong1 & $FF)
  Define.i Minor = (xLong1 & $FF00) >> 8
  
  xSysPath = GetWinSysPath()
  If TestForDLL(xSysPath + "dsound.dll", $40003) = 0
    xNoDirectX = 1
    VersionID = -1
    ProcedureReturn 0
    EndIf
  VersionID = GetFileVersionEx("bass.dll", @RevisionID)
  If VersionID > $20004 Or (VersionID = $20004 And RevisionID > $7ffff)
    If Not IsUnicode
      If Major < 4 Or (Major = 4 And Minor < 10)
        OSToNew = 1
        ProcedureReturn 0
        EndIf
      EndIf
    EndIf
      ;Debug Hex(VersionID) + " - " + Hex(RevisionID)
  *BassDLL = OpenLibrary(#PB_Any, "bass.dll")
  If *BassDLL
    GetPreFuncs()
    If ctSSLayer_CanUseItem($20) < 20
      EnumerateDrv(MainHWnd)
      ProcedureReturn OutPutListCount
      EndIf
    Else
    VersionID = -1
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_ReadTags
  XIncludeFile "ctSSLayer_Common_LocalAllocStringWFromAnsiOrUTF8Mem.pb" ;- LocalAllocStringWFromAnsiOrUTF8Mem
  
  Procedure.i ReadThisTagTxt(*SongPointer, *MemToUse, WhatFormatStr.s, Unicode.i)
    Define.i xLong1
    Define.i xLong2
    Define.s xChar1

    xLong1 = PeekL(*MemToUse)
    If xLong1
      FreeMemory(xLong1)
      EndIf
    If Unicode And TagRVersion > 14
      WhatFormatStr = "%UTF8(" + WhatFormatStr + ")"
      EndIf
    xLong1 = CallFunctionFast(*TAGS_Read, *SongPointer, @WhatFormatStr)
;Debug "Call"
    If xLong1
;Debug "Has1"
      If Unicode And TagRVersion > 14
;Debug "UseUTF: " + PeekS(xLong1)
        xLong2 = LocalAllocStringWFromAnsiOrUTF8Mem(xLong1, 65001)
        Else
        xChar1 = PeekS(xLong1)
        xLong2 = Len(xChar1)
        If xLong2
  ;Debug "Has2"
          If Unicode
            xLong2 = AllocateMemory((xLong2 + 1) * 2)
            If xLong2
              PokeS(xLong2, xChar1, -1, #PB_Unicode)
              EndIf
            Else
  ;Debug "Has3"
            xLong2 = AllocateMemory(xLong2 + 1)
            If xLong2
  ;Debug "Has4"
              PokeS(xLong2, xChar1)
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
    PokeL(*MemToUse, xLong2)
;If (xLong2)    
;Debug "Has5: " + Str(xLong2)+" / "+ xChar1
;EndIf
    ProcedureReturn xLong2
    EndProcedure
  
  Procedure.i ReadThisTagLng(*SongPointer, *WhatFormatStr)
    Define.i xLong1

    xLong1 = CallFunctionFast(*TAGS_Read, *SongPointer, *WhatFormatStr)
    If xLong1
      ProcedureReturn Val(Trim(PeekS(xLong1)))
      EndIf
    EndProcedure

  Procedure.i TagParseAllocAnsi(xString.s, *MemToUse, Unicode.i)
    Define.i xResult
    Define.i xLong1

    xLong1 = PeekI(*MemToUse)
    If xLong1
      FreeMemory(xLong1)
      PokeI(*MemToUse, 0)
      EndIf
    xLong1 = Len(xString)
    If xLong1
      If Unicode
        xResult = AllocateMemory((xLong1 + 1) << 1)
        If xResult
          PokeS(xResult, xString, xLong1, #PB_Unicode)
          EndIf
        Else
        xResult = AllocateMemory(xLong1 + 1)
        If xResult
          PokeS(xResult, xString, xLong1, #PB_Ascii)
          EndIf
        EndIf
      EndIf
    If xResult
      PokeI(*MemToUse, xResult)
      EndIf
    ProcedureReturn xResult
    EndProcedure

  Procedure TagParseSingleAnsi(*Mem, *xSongInfo.ctSSSongInfoStruct, Unicode.i)
    Debug "Parsing: " + PeekS(*Mem)
    Define.s xChar1
    xChar1 = LCase(PeekS(*Mem))
    
    If Not *xSongInfo\IR_Name
      If Left(xChar1, 9) = "icy-name:"
        *xSongInfo\IR_Name = TagParseAllocAnsi(Trim(PeekS(*Mem + 9)), @MemIRNam, Unicode)
        EndIf
      EndIf
    If Not *xSongInfo\IR_URL
      If Left(xChar1, 8) = "icy-url:"
        *xSongInfo\IR_URL = TagParseAllocAnsi(Trim(PeekS(*Mem + 8)), @MemIRURL, Unicode)
        EndIf
      EndIf
    EndProcedure

  Procedure TagParseMultiAnsi(*Mem, *xSongInfo, Unicode.i)
    Define.i xLong1
    Repeat
      xLong1 = lstrlen_(*Mem)
      If Not xLong1
        Break
        EndIf
      TagParseSingleAnsi(*Mem, *xSongInfo, Unicode)
      *Mem + xLong1 + 1
      ForEver
    EndProcedure

;  Procedure TagParseIcyMeta(*Mem, *xSongInfo.ctSSSongInfoStruct, Unicode.i)
    ;EndProcedure

  Procedure.i ctSSLayer_ReadSongInfo(*SongPointer.tSong, *xSongInfo.ctSSSongInfoStruct, Unicode.i)
    Define.ctSSSongInfoStruct xType1
    Define.BASS_CHANNELINFO xType2

    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      Define *Mem
      Define.q xQuad1
      Define.i xLong1
      ;#BASS_TAG_ID3 = 0                ' ID3v1 tags : TAG_ID3 Structure
      ;#BASS_TAG_ID3V2 = 1              ' ID3v2 tags : variable length block
      ;#BASS_TAG_OGG = 2                ' OGG comments : series of null-terminated UTF-8 strings
      #BASS_TAG_HTTP = 3               ; HTTP headers : series of null-terminated ANSI strings
      #BASS_TAG_ICY = 4                ; ICY headers : series of null-terminated ANSI strings
      ;#BASS_TAG_META = 5               ; ICY metadata : ANSI string
      ;#BASS_TAG_APE = 6                ' APEv2 tags : series of null-terminated UTF-8 strings
      ;#BASS_TAG_MP4 = 7                ' MP4/iTunes metadata : series of null-terminated UTF-8 strings
      ;#BASS_TAG_VENDOR = 9             ' OGG encoder : UTF-8 string
      ;#BASS_TAG_LYRICS3 = 10           ' Lyric3v2 tag : ASCII string
      ;#BASS_TAG_CA_CODEC = 11          ' CoreAudio codec info : TAG_CA_CODEC structure
      ;#BASS_TAG_MF = 13                ' Media Foundation tags : series of null-terminated UTF-8 strings
      ;#BASS_TAG_WAVEFORMAT = 14        ' WAVE format : WAVEFORMATEEX structure
      ;#BASS_TAG_RIFF_INFO = $100      ' RIFF "INFO" tags : series of null-terminated ANSI strings
      ;#BASS_TAG_RIFF_BEXT = $101      ' RIFF/BWF "bext" tags : TAG_BEXT structure
      ;#BASS_TAG_RIFF_CART = $102      ' RIFF/BWF "cart" tags : TAG_CART structure
      ;#BASS_TAG_RIFF_DISP = $103      ' RIFF "DISP" text tag : ANSI string
      ;#BASS_TAG_APE_BINARY = $1000    ' + index #, binary APEv2 tag : TAG_APE_BINARY structure
      ;#BASS_TAG_MUSIC_NAME = $10000   ' MOD music name : ANSI string
      ;#BASS_TAG_MUSIC_ORDERS = $10002 ' MOD order list : BYTE array of pattern numbers
      ;#BASS_TAG_MUSIC_MESSAGE = $10001 ' MOD message : ANSI string
      ;#BASS_TAG_MUSIC_INST = $10100   ' + instrument #, MOD instrument name : ANSI string
      ;#BASS_TAG_MUSIC_SAMPLE = $10300 ' + sample #, MOD sample name : ANSI string
      ;Global *BASS_StreamChannelGetTags = GetFunction(*BassDLL, "BASS_StreamGetTags")
      CompilerEndIf

    ;Global strTitle.s
    ;Global strArtist.s
    ;Global strAlbum.s
  
    ;ProcedureReturn 1
    ;MessageRequester("1", "2")
    If CallFunctionFast(*BASS_ChannelGetInfo, *SongPointer\Pointer, @xType2)
  ;      ProcedureReturn 1
      ;xLong1 = CreateFile_(FileName, #BASS_UNICODE, 1, #Null, 3, $20, 0)
      ;MessageRequester("1", "3")
      ;If xLong1
      ;  xLong2 = GetFileSize_(xLong1, #Null)
      ;  CloseHandle_(xLong1)

CompilerIf #ctSSLayer_CompiledFeature_InetStreams
      If *SongPointer\mode = #BassLayer_ModeINet
        ;*SongPointer\Format_QualityMulti = 1
        xType1\Format_Channels = xType2\chans
        xType1\Format_Frequency = xType2\freq
        xType1\FormatOK = 1
        PokeF(@xType1\Format_QualityMulti, 1)
        xLong1 = CallFunctionFast(*BASS_GetConfig, #BASS_CONFIG_NET_BUFFER)
;Debug "NETBUFFER: " + Str(xLong1)
        If xLong1 > 0
          If VersionID > $20003
            xQuad1 = BASS_StreamGetFilePosition24(*SongPointer\Pointer, #BASS_FILEPOS_END)
            Else
            xQuad1 = CallFunctionFast(*BASS_StreamGetFilePosition23, *SongPointer\Pointer, #BASS_FILEPOS_END)
            EndIf
;Debug "FILEPOSEND: " + Str(xQuad1)
          xQuad1 = (xQuad1 << 3) / xLong1
          EndIf
        If xQuad1 < $ffffff
          xType1\Format_BitRate = xQuad1
          EndIf
        RtlMoveMemory_(*xSongInfo, @xType1, SizeOf(xType1))
        ElseIf *SongPointer\FileSize
CompilerElse
      If *SongPointer\FileSize
CompilerEndIf
        ;MessageRequester("1", "3")
        If *SongPointer\Size
          xType1\Format_BitRate = *SongPointer\FileSize / *SongPointer\Size * 8000
          EndIf
        xType1\Format_Channels = xType2\chans
        xType1\Format_Frequency = xType2\freq
        xType1\FormatOK = 1
        PokeF(@xType1\Format_QualityMulti, *SongPointer\Format_QualityMulti)
        ;MessageRequester("1", "7")
        RtlMoveMemory_(*xSongInfo, @xType1, SizeOf(xType1))
        EndIf
      EndIf


;Debug "TagReader1"
;Debug "*TAGS_Read: " + Str(*TAGS_Read)
    If *TAGS_Read
;Debug "TagReader2"
      *xSongInfo\Tag_Album   = ReadThisTagTxt(*SongPointer\Pointer, @MemAlbum, "%ALBM", Unicode)
      *xSongInfo\Tag_Artist  = ReadThisTagTxt(*SongPointer\Pointer, @MemArtst, "%ARTI", Unicode)
      *xSongInfo\Tag_Title   = ReadThisTagTxt(*SongPointer\Pointer, @MemTitle, "%TITL", Unicode)
      *xSongInfo\Tag_TrackID = ReadThisTagLng(*SongPointer\Pointer, @"%TRCK")
      *xSongInfo\Tag_Year    = ReadThisTagLng(*SongPointer\Pointer, @"%YEAR")
      *xSongInfo\TagOK = 1


;Debug "*BASS_StreamChannelGetTags: " + Str(*BASS_StreamChannelGetTags)
      CompilerIf #ctSSLayer_CompiledFeature_ReadTags
        If *BASS_StreamChannelGetTags
          *Mem = CallFunctionFast(*BASS_StreamChannelGetTags, *SongPointer\Pointer, #BASS_TAG_HTTP)
          TagParseMultiAnsi(*Mem, *xSongInfo, Unicode)
          *Mem = CallFunctionFast(*BASS_StreamChannelGetTags, *SongPointer\Pointer, #BASS_TAG_ICY)
          TagParseMultiAnsi(*Mem, *xSongInfo, Unicode)
          ;*Mem = CallFunctionFast(*BASS_StreamChannelGetTags, *SongPointer\Pointer, #BASS_TAG_META)
          ;TagParseIcyMeta(*Mem, *xSongInfo, Unicode)
          EndIf

        ;#BASS_TAG_OGG = 2                ' OGG comments : series of null-terminated UTF-8 strings
        ;#BASS_TAG_APE = 6                ' APEv2 tags : series of null-terminated UTF-8 strings
        ;#BASS_TAG_VENDOR = 9             ' OGG encoder : UTF-8 string
  
        ;#BASS_TAG_ID3 = 0                ' ID3v1 tags : TAG_ID3 Structure
        ;#BASS_TAG_ID3V2 = 1              ' ID3v2 tags : variable length block
        ;#BASS_TAG_MP4 = 7                ' MP4/iTunes metadata : series of null-terminated UTF-8 strings
        ;#BASS_TAG_LYRICS3 = 10           ' Lyric3v2 tag : ASCII string
        ;#BASS_TAG_CA_CODEC = 11          ' CoreAudio codec info : TAG_CA_CODEC structure
        ;#BASS_TAG_MF = 13                ' Media Foundation tags : series of null-terminated UTF-8 strings
        ;Global *BASS_StreamChannelGetTags = GetFunction(*BassDLL, "BASS_StreamGetTags")
        CompilerEndIf
      

      ;CallFunctionFast(*TAGS_Read, *SongPointer\Pointer, 
      EndIf
    
;Define.i xLong1    
;Unicode = 1
;Define.i xLong2 = ReadThisTagTxt(*SongPointer\Pointer, @xLong1, "123%REPLA321", Unicode)
;If xLong2
;  If Unicode
;    Debug "RG:"+PeekS(xLong2, -1, #PB_Ascii)
;    Else
;    Debug "RG:"+PeekS(xLong2, -1, #PB_Unicode)
;    EndIf
;  If xLong1: FreeMemory(xLong2):EndIf
;  EndIf
    
    ;MessageRequester("1", "8")
    ;*xSongInfo\Tag_Title = @strTitle
    ;*xSongInfo\Tag_Artist = @strArtist
    ;*xSongInfo\Tag_Album = @strAlbum
    ProcedureReturn 1
    EndProcedure
  
  CompilerIf #ctSSLayer_CompiledFeature_ReadTagsA
    ProcedureDLL.i ctSSLayer_ReadSongInfoA(*SongPointer.tSong, *xSongInfo.ctSSSongInfoStruct)
      ProcedureReturn ctSSLayer_ReadSongInfo(*SongPointer, *xSongInfo, 0)
      EndProcedure
    CompilerEndIf

  CompilerIf #ctSSLayer_CompiledFeature_ReadTagsW
    ProcedureDLL.i ctSSLayer_ReadSongInfoW(*SongPointer, *xSongInfo)
      ProcedureReturn ctSSLayer_ReadSongInfo(*SongPointer, *xSongInfo, 1)
      EndProcedure
    CompilerEndIf
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_RefreshDeviceList
  ProcedureDLL.i ctSSLayer_RefreshDeviceList(hWnd.i)
    ProcedureReturn OutPutListCount
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_SoundFontRefreshList(Flags.i)
    CompilerIf #BASS_UseMidi
      ClearSoundFontList()
      SoundFontListFlags = Flags
      GetSoundFonts(#False)
      ProcedureReturn SoundFontListCount
      CompilerEndIf
    EndProcedure

ProcedureDLL.i ctSSLayer_SeekSong(*SongPointer.tSong, SeekPosition.i)
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
  If *SongPointer\Mode And Not *SongPointer\Mode = #BassLayer_ModeINet
CompilerElse
  If *SongPointer\Mode
CompilerEndIf
    If SeekPosition > -1 And *SongPointer\Size > 0 And (SeekPosition < *SongPointer\Size Or *SongPointer\Mode = #BassLayer_ModeTracker And SeekPosition < *SongPointer\ExtraA)
      ;PrintN("Seeking...")
      ;PrintN("  " + Str(*SongPointer\Pointer))
      ;PrintN("  " + Str(SeekPosition / 1000))
      ;PrintN("  " + Str(BASS_ChannelSeconds2Bytes(*SongPointer\Pointer, SeekPosition / 1000)))
      If VersionID > $20003
        BASS_ChannelSetPosition24(*SongPointer\Pointer, BASS_ChannelSeconds2Bytes24(*SongPointer\Pointer, SeekPosition / 1000), #BASS_POS_BYTE)
        Else
        BASS_ChannelSetPosition23(*SongPointer\Pointer, BASS_ChannelSeconds2Bytes23(*SongPointer\Pointer, SeekPosition / 1000))
        EndIf
      ;PrintN("  done")
      If *SongPointer\ShouldPlay
        ;PrintN("  TestDoesPlay")
        Select CallFunctionFast(*BASS_ChannelIsActive, *SongPointer\Pointer)
          Case #BASS_ACTIVE_STALLED, #BASS_ACTIVE_STOPPED
            ;PrintN("  MustPlay")
            CallFunctionFast(*BASS_ChannelPlay, *SongPointer\Pointer, 0)
          EndSelect
        ;PrintN("  k")
        EndIf
      ProcedureReturn 1
      EndIf
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
  ProcedureDLL.i ctSSLayer_SetEndCallback(HWnd.i, Message.i, wParam.i)
    EndProcedure
  CompilerEndIf

ProcedureDLL ctSSLayer_SetPause(*SongPointer.tSong, Pause.i)
;  If ResumeVolume = -1
;    ResumeVolume = *SongPointer\CurVolume
;    Else
;    *SongPointer\CurVolume = ResumeVolume
;    EndIf

CompilerIf #ctSSLayer_CompiledFeature_InetStreams
  If *SongPointer\Mode = #BassLayer_ModeINet
    If Pause
      If VersionID > $20003
        BASS_ChannelSetAttribute24(*SongPointer\Pointer, #BASS_ATTRIB_VOL, 0)
        Else
        BASS_ChannelSetAttributes23(*SongPointer\Pointer, 0, 0, 0)
        EndIf
      Else
      If VersionID > $20003
        BASS_ChannelSetAttribute24(*SongPointer\Pointer, #BASS_ATTRIB_VOL, *SongPointer\CurVolume / 255)
        Else
        BASS_ChannelSetAttributes23(*SongPointer\Pointer, 0, *SongPointer\CurVolume / 255, 0)
        EndIf
      EndIf
    *SongPointer\ShouldPlay = Pause
    ElseIf *SongPointer\Mode
CompilerElse
  If *SongPointer\Mode
CompilerEndIf
    If Pause
      CallFunctionFast(*BASS_ChannelPause, *SongPointer\Pointer)
      Else
      CallFunctionFast(*BASS_ChannelPlay, *SongPointer\Pointer, #False)
      EndIf
    *SongPointer\ShouldPlay = Pause
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  ProcedureDLL ctSSLayer_SetSpectrum(Status.i)
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_SoundFontGetCurrent()
  CompilerIf #BASS_UseMidi
    Define.i xResult
    Define.i xLong1

    xResult = -1
    If SoundFontListCount And CurSoundFont
      For xLong1 = 0 To SoundFontListCount - 1
        If Not lstrcmpiW(SoundFontList(xLong1), CurSoundFont)
          xResult = xLong1
          Break
          EndIf
        Next
      ProcedureReturn xResult
      Else
      ProcedureReturn -1
      EndIf
    CompilerEndIf
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontSet(FontID.i)
  CompilerIf #BASS_UseMidi
    Define.i xResult

    GetPreFuncs()
    If CurSoundFont And FontID >= 0 And FontID < SoundFontListCount
      If lstrcmpiW(SoundFontList(FontID), CurSoundFont)
        xResult = ApplySoundFont(FontID)
        Else
        xResult = #True
        EndIf
      EndIf
    ProcedureReturn xResult
    CompilerEndIf
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontNumAffectedFiles()
  CompilerIf #BASS_UseMidi
    ProcedureReturn MidiCounter
    CompilerEndIf
  EndProcedure

ProcedureDLL ctSSLayer_SetVolume(*SongPointer.tSong, Volume.i)
  ;*SongPointer\CurVolume = Volume
  If *SongPointer\Mode
    CompilerIf #ctSSLayer_CompiledFeature_InetStreams
      *SongPointer\CurVolume = Volume
      CompilerEndIf
    If VersionID > $20003
      BASS_ChannelSetAttribute24(*SongPointer\Pointer, #BASS_ATTRIB_VOL, (Volume / 255))
      Else
      BASS_ChannelSetAttributes23(*SongPointer\Pointer, 0, (Volume / 2.55), 0)
      EndIf
    EndIf
  EndProcedure

; Beware! Can be 0 ... esp. after you round it!
ProcedureDLL.i ctSSLayer_SongLength(*SongPointer.tSong)
  If *SongPointer\Mode
    ProcedureReturn *SongPointer\Size
    EndIf
  EndProcedure

ProcedureDLL ctSSLayer_UnloadSong(*SongPointer.tSong) ;, RestoreVolume.i)
  Select *SongPointer\Mode
    Case 0 ;, #BassLayer_ModeCDDA
    Case #BassLayer_ModeTracker
      CallFunctionFast(*BASS_MusicFree, *SongPointer\Pointer)
    Default
      CallFunctionFast(*BASS_StreamFree, *SongPointer\Pointer)
      CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
        If *SongPointer\Mode = #BassLayer_ModeCDDA
          IsCDing = 0
          EndIf
        CompilerEndIf
    EndSelect
  ;*SongPointer\Mode = 0
  FreeMemory(*SongPointer)
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
  ProcedureDLL ctSSLayer_UpdateCDDA(UseCDDA.i, UseJitterCorrection.i)
    ;xUseCDDA = (UseCDDA And ctSSLayer_CanUseItem(0))
    ;xUseJitter = UseJitterCorrection And ctSSLayer_CanUseItem(1)
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased = 2
  ProcedureDLL ctSSLayer_UpdateLooping(*SongPointer, LoopSong.i)
    EndProcedure
  CompilerEndIf  

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
  ProcedureDLL ctSSLayer_UpdatePanning(*SongPointer.tSong, Panning.i)
    If *SongPointer\Mode
      If VersionID > $20003
        BASS_ChannelSetAttribute24(*SongPointer\Pointer, #BASS_ATTRIB_MUSIC_PANSEP, Panning)
        Else
        CallFunctionFast(*BASS_MusicSetAttribute23, *SongPointer\Pointer, 1, Panning) ; * 100)
        EndIf
      EndIf
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_Version(OptionalLayerVersionID.i)
  Select OptionalLayerVersionID
    Case 0, $10000682, $10000690, $10001010, $10001103
      ProcedureReturn $10001103
    EndSelect
  EndProcedure














CompilerIf #TestIT = 3
  Procedure.i MyDebugger(xChar1.s, Mode.i)
    OutputDebugString_(@xChar1)
    Debug xChar1
    EndProcedure
  
  Procedure DebugX(xChar1.s)
    OutputDebugString_(@xChar1)
    Debug xChar1
    EndProcedure

  DebugX("1")
  AttachProcess(0)

  ctSSLayer_SetDebuggerA(@MyDebugger(), #False)

  If ctSSLayer_Version($10000682)
    Define.i xLong2 = ctsslayer_preinit(0)
    If xLong2
      DebugX(PeekS(ctsslayer_getinfostringa($1)) + " " + PeekS(ctsslayer_getinfostringa($30)))
      Define.i xLong1
      For xLong1 = 0 To xLong2 - 1
        DebugX(PeekS(ctSSLayer_GetDeviceNameA(xLong1, 0)) + "#")
        DebugX("  " + PeekS(ctSSLayer_GetDeviceSSLIDA(xLong1)) + "#")
        DebugX("    " + Str(ctSSLayer_GetDeviceFromSSLIDA(ctSSLayer_GetDeviceSSLIDA(xLong1))))
        DebugX(PeekS(ctSSLayer_GetDeviceNameW(xLong1, 0), -1, #PB_Unicode) + "#")
        DebugX("  " + PeekS(ctSSLayer_GetDeviceSSLIDW(xLong1), -1, #PB_Unicode) + "#")
        DebugX("    " + Str(ctSSLayer_GetDeviceFromSSLIDW(ctSSLayer_GetDeviceSSLIDW(xLong1))))
        Next
      xLong2 = ctSSLayer_CanUseItem($1A)
      Debug "SoundFonts: " + Str(xLong2)
      For xLong1 = 0 To xLong2 - 1
        DebugX(Str(xLong1) + ": " + PeekS(ctSSLayer_SoundFontGetCaptionA(xLong1)) + " (" + StrU(SoundFontSize(xLong1)) + "bytes)")
        ;Debug(Str(xLong1) + ": " + PeekS(ctSSLayer_SoundFontGetCaptionW(xLong1), -1, #PB_Unicode) + "#")
        ;Debug(Str(xLong1) + ": " + PeekS(ctSSLayer_SoundFontGetFilenameA(xLong1)) + "#")
        ;Debug(Str(xLong1) + ": " + PeekS(ctSSLayer_SoundFontGetFilenameW(xLong1), -1, #PB_Unicode) + "#")
        Next

      InfoString = ""
      GetSoundFontInfo()
      DebugX("Current(" + Str(ctSSLayer_SoundFontGetCurrent()) + "): " + InfoString)

      ctSSLayer_SoundFontSet(1)
      InfoString = ""
      GetSoundFontInfo()
      DebugX("Current(" + Str(ctSSLayer_SoundFontGetCurrent()) + "): " + InfoString)

      ;ctSSLayer_SoundFontSet(0)
      InfoString = ""
      GetSoundFontInfo()
      DebugX("Current(" + Str(ctSSLayer_SoundFontGetCurrent()) + "): " + InfoString)

      ;ctSSLayer_SoundFontSet(0)
      InfoString = ""
      GetSoundFontInfo()
      DebugX("Current(" + Str(ctSSLayer_SoundFontGetCurrent()) + "): " + InfoString)
;
  
      If ctsslayer_init(0, 0, 0, 0)
        DebugX("inited")
        ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeCDAudio, @"r:\track01.cda", 1)
        ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeInetStream, @"http://91.121.13.103:8080", 3)
        ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeInetStream, @"http://85.25.209.116:9000/128.OPUS", 3)
        ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeInetStream, @"http://zaphod.mediacafe.ro:8000/clandestino.ogg", 3)
        ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeStream, @"C:\AIMP23\Mass Effect 3 - Main Theme Remix (Plasma3Music).mp3", 3)
        Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeTracker, @"D:\DEV\Software\LineSpec\x\Demo applications\source\lyrics\Coldplay - The scientist.mid", 3)
        If xLong1
          Repeat
            DebugX("loadok, blockwaiting")
            Delay(200)
            Select ctSSLayer_LoadSongFinished(xLong1)
              Case 0: DebugX("  still Waiting")
              Case 1: DebugX("  ok")
                xLong2 = #True
                Break
              Case -1: : DebugX("  failed")
                xLong2 = #False
                Break
              EndSelect
            ForEver
          If xLong2
            Define.ctSSSongInfoStruct xType1
            ctsslayer_readsonginfoa(xLong1, @xType1)
            If xType1\Tag_Album
              Debug "Album: " + PeekS(xType1\Tag_Album)
              EndIf
            If xType1\Tag_Artist
              Debug "Artist: " + PeekS(xType1\Tag_Artist)
              EndIf
            If xType1\Tag_Title
              Debug "Title: " + PeekS(xType1\Tag_Title)
              EndIf
            If xType1\IR_Name
              Debug "IRName: " + PeekS(xType1\IR_Name)
              EndIf
            If xType1\IR_URL
              Debug "IRURL: " + PeekS(xType1\IR_URL)
              EndIf
            Debug "Year: " + Str(xType1\Tag_Year)
            Debug "Track: " + Str(xType1\Tag_TrackID)
            Debug "BitRate: " + Str(xType1\Format_BitRate)
  
            Debug "Play?: " + Str(ctsslayer_loadsongplay(xLong1, 255, 0, 80, 0))
            For xLong2 = 0 To 200
              Debug "Position: " + Str(ctSSLayer_GetPosition(xLong1))
              Delay(100)
              Next
            EndIf
          ctsslayer_unloadsong(xLong1)
          EndIf
  Debug "f4"
  Debug ctsslayer_CanUseItem($11)
        ctsslayer_close(#False)
  Debug "f5"
        EndIf
      EndIf
    EndIf

;Sleep_(5000)  
  ;DetachProcess(0)
;Sleep_(2000)
  CompilerEndIf

CompilerIf #TestIT = 4 And #Console
  Debug "1"
  AttachProcess(0)
  If ctSSLayer_Version($10000682)
    Define.i xLong2 = ctsslayer_preinit(0)
    Debug(Str(VersionID >> 16) + "." + Right("0" + Hex(VersionID & $FF), 2))
    Debug(Hex(VersionID))
    If xLong2
      Debug PeekS(ctsslayer_getinfostringa($1)) + " " + PeekS(ctsslayer_getinfostringa($30))
      Define.i xLong1
      For xLong1 = 0 To xLong2 - 1
        Debug("W->A: " + PeekS(ctSSLayer_GetDeviceNameW(xLong1, 0), -1, #PB_Unicode) + "#")
        Debug("   A: " + PeekS(ctSSLayer_GetDeviceNameA(xLong1, 0)) + "#")
        Debug("Guid: " + PeekS(ctSSLayer_GetDeviceSSLIDA(xLong1)) + "#")
        Next
      EndIf
    EndIf
;Sleep_(10000)  
  ;DetachProcess(0)
  CompilerEndIf


CompilerIf #TestIT = 6 And #Console
  AttachProcess(0)
  If ctsslayer_preinit(0)
    Debug PeekS(ctsslayer_getinfostringa($1)) + " " + PeekS(ctsslayer_getinfostringa($30))
    If ctsslayer_init(0, 0, 0, 0)
      Debug "inited"
      ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeCDAudio, @"r:\track01.cda", 1)
      ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeInetStream, @"http://91.121.13.103:8080", 3)
      ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeStream, @"C:\Q0511N\USERDATA\Desktop\trl_main_theme0.wv", 1)
      Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeStream, @"E:\_New\2010\Hatlelid\[Ar] 3d10 4s2 - test drive 2.mp3", 1)
      If xLong1
        Debug "loadok"
        Repeat
          Debug "blockwaiting"
          Delay(200)
          Select ctSSLayer_LoadSongFinished(xLong1)
            Case 0: Debug "  still Waiting"
            Case 1: Debug "  ok"
              Break
            Case -1: : Debug "  failed"
              Goto NoPlay
            EndSelect
          ForEver
        ctsslayer_loadsongplay(xLong1, 255, 0, 80, 0)
        Define.ctSSSongInfoStruct xType1
        ctsslayer_readsonginfoa(xLong1, @xType1)
        If xType1\Tag_Album
          Debug "A_Album:  " + PeekS(xType1\Tag_Album)
          EndIf
        If xType1\Tag_Artist
          Debug "A_Artist: " + PeekS(xType1\Tag_Artist)
          EndIf
        If xType1\Tag_Title
          Debug "A_Title:  " + PeekS(xType1\Tag_Title)
          EndIf
        ctsslayer_readsonginfow(xLong1, @xType1)
        If xType1\Tag_Album
          Debug "W_Album:  " + PeekS(xType1\Tag_Album, -1, #PB_Unicode)
          EndIf
        If xType1\Tag_Artist
          Debug "W_Artist: " + PeekS(xType1\Tag_Artist, -1, #PB_Unicode)
          EndIf
        If xType1\Tag_Title
          Debug "W_Title:  " + PeekS(xType1\Tag_Title, -1, #PB_Unicode)
          EndIf
        Debug "Track:  " + Str(xType1\Tag_TrackID)
        Debug "Year:  " + Str(xType1\Tag_Year)
NoPlay:
ctsslayer_unloadsong(xLong1)
        EndIf
      ctsslayer_close(#False)
Debug "f5"
      EndIf
    EndIf

  ;DetachProcess(0)
  CompilerEndIf

CompilerIf #TestIT = 7 And #Console
  Procedure DebugML(xChar1.s)
    Define.i xLong1

    xChar1 = xChar1 + Chr(13) + Chr(10)
    Repeat
      xLong1=FindString(xChar1, Chr(13)+Chr(10),1)
      If xLong1 = 0: Break: EndIf
      Debug Left(xChar1, xLong1 - 1)
      xChar1 = Mid(xChar1, xLong1 + 2)
      ForEver
    EndProcedure
  
  
  AttachProcess(0)
  If ctsslayer_preinit(0)
    Debug PeekS(ctsslayer_getinfostringa($1)) + " " + PeekS(ctsslayer_getinfostringa($30))
    DebugML(PeekS(ctsslayer_getinfostringa($a)))
    
    If ctsslayer_init(0, 0, 0, 0)
      Debug "inited"
      Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeStream, @"C:\Within Temptation - Memories12687.mid", 1)
      ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeStream, @"E:\_New\201202\Arrival to Earth.mid", 1)
      If xLong1
        Debug "loadok"
        Repeat
          Debug "blockwaiting"
          Delay(200)
          Select ctSSLayer_LoadSongFinished(xLong1)
            Case 0: Debug "  still Waiting"
            Case 1: Debug "  ok"
              Break
            Case -1: : Debug "  failed"
              Goto NoPlay
            EndSelect
          ForEver
        ctsslayer_loadsongplay(xLong1, 255, 0, 80, 0)
        Sleep_(10000)
NoPlay:
ctsslayer_unloadsong(xLong1)
        EndIf
      ctsslayer_close(#False)
Debug "f5"
      EndIf
    EndIf

  ;DetachProcess(0)
  CompilerEndIf

CompilerIf #TestIT = 8 And #Console
  AttachProcess(0)
  Define.i xLong3
  For xLong3 = 0 To 4
    Define.i xLong2 = ctsslayer_preinit(0)
    Debug(Str(VersionID >> 16) + "." + Right("0" + Hex(VersionID & $FF), 2))
    Debug(Hex(VersionID))
    If xLong2
      Debug PeekS(ctsslayer_getinfostringa($1)) + " " + PeekS(ctsslayer_getinfostringa($30))
      Define.i xLong1
      For xLong1 = 0 To xLong2 - 1
        Debug("W->A: " + PeekS(ctSSLayer_GetDeviceNameW(xLong1, 0), -1, #PB_Unicode) + "#")
        Debug("   A: " + PeekS(ctSSLayer_GetDeviceNameA(xLong1, 0)) + "#")
        Debug("Guid: " + PeekS(ctSSLayer_GetDeviceSSLIDA(xLong1)) + "#")
        Next
      EndIf
    If ctsslayer_init(0, 0, 0, 0)
      Debug "inited"
      Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeStream, @"C:\Within Temptation - Memories12687.mid", 1)
      ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeStream, @"E:\_New\201202\Arrival to Earth.mid", 1)
      If xLong1
        Debug "loadok"
        Repeat
          Debug "blockwaiting"
          Delay(200)
          Select ctSSLayer_LoadSongFinished(xLong1)
            Case 0: Debug "  still Waiting"
            Case 1: Debug "  ok"
              Break
            Case -1: : Debug "  failed"
              Goto NoPlay
            EndSelect
          ForEver
        ctsslayer_loadsongplay(xLong1, 255, 0, 80, 0)
        Sleep_(1000)
NoPlay:
ctsslayer_unloadsong(xLong1)
        EndIf
      ctsslayer_close(#False)
Debug "f5"
      EndIf
    Next
  
  ;DetachProcess(0)
  CompilerEndIf


; IDE Options = PureBasic 5.31 (Windows - x64)
; ExecutableFormat = Shared Dll
; CursorPosition = 908
; FirstLine = 892
; Folding = ---------------------------------
; EnableThread
; Executable = ctssly64.dll
; CurrentDirectory = ..\Calaym64\
; CompileSourceDirectory
; VersionField0 = 1,0,0,5600
; VersionField1 = 1,0,0,5600
; VersionField2 = ctuser
; VersionField3 = ctSSLayer
; VersionField4 = 1.00 beta 56
; VersionField5 = 1.00 beta 56 (2006.09.23)
; VersionField6 = BASS sound system layer
; VersionField7 = ctSSLay
; VersionField8 = ctSSLay.dll
; VersionField9 = Copyright 2002-2006 by Jan Vorel; Published under the GNU General Public License
; VersionField16 = VFT_DLL
; VersionField18 = Comments
; VersionField21 = Published under the GNU General Public License; homepage: http://www.ctuser.net; Uses BASS soundsystem: http://www.un4seen.com; compressed with upx: http://upx.sourceforge.net
; AddResource = ctSSLayer_BASS.rc