EnableExplicit

LibBuild_Include(GetFullPathName)

Declare AppBase_SetEx(xChar1.s, ForReal.i, ExtMode.i, CmdParamMode.i)

Procedure AppBase_LibBuildPostInit()
  Global LibBuild_BasePathRealExe.s
  Global LibBuild_BasePathNoExt.s
  Global LibBuild_BasePathJustPath.s
  Define.i xLong1
  Define.s xChar1

  xLong1 = GetCommandLine_()
  If xLong1
    xChar1 = PeekS(xLong1)
    If Len(xChar1)
      AppBase_SetEx(xChar1, #True, #True, #True)
      EndIf
    EndIf
  EndProcedure

Procedure AppBase_SetEx(xChar1.s, ForReal.i, ExtMode.i, CmdParamMode.i)
  Define.i xLong1
  Define.i xLong2

  xChar1 = Trim(xChar1)
  If Left(xChar1, 1) = Chr(34)
    xLong1 = FindString(xChar1, Chr(34), 2)
    If xLong1
      xChar1 = Mid(xChar1, 2, xLong1 - 2)
      Else
      xChar1 = Mid(xChar1, 2)
      EndIf
    ElseIf CmdParamMode
    xLong1 = FindString(xChar1, " ")
    If xLong1
      xChar1 = Left(xChar1, xLong1 - 1)
      EndIf
    EndIf
  xChar1 = GetFullPathName(xChar1)
  If ForReal
    LibBuild_BasePathRealExe = xChar1
    EndIf

  xLong1 = InStrRevChar(xChar1, 92) ;"\"
  If ExtMode
    xLong2 = InstrRevChar(xChar1, 46) ; "."
    EndIf
  If xLong2 > xLong1
    LibBuild_BasePathNoExt = Left(xChar1, xLong2 - 1)
    Else
    LibBuild_BasePathNoExt = xChar1
    EndIf
  If xLong1
    LibBuild_BasePathJustPath = Left(xChar1, xLong1 - 1)
    Else
    LibBuild_BasePathJustPath = ""
    EndIf
  EndProcedure

Macro AppBase_SetByFull(xString)
  AppBase_SetEx(xString, #False, #True, #False)
  EndMacro

Macro AppBase_SetByPathBaseFile(xString)
  AppBase_SetEx(xString, #False, #False, #False)
  EndMacro

Macro AppBase_SetByPathBaseFileCmdParam(xString)
  AppBase_SetEx(xString, #False, #True, #True)
  EndMacro

Macro AppBase_ResetToReal()
  AppBase_SetEx(LibBuild_BasePathRealExe, #True, #False, #False)
  EndMacro

Macro AppBase_GetByExt(ExtensionToAdd)
  LibBuild_BasePathNoExt + "." + ExtensionToAdd
  EndMacro

Macro AppBase_GetPathBaseFile()
  LibBuild_BasePathNoExt
  EndMacro

Macro AppBase_GetRealExename()
  LibBuild_BasePathRealExe
  EndMacro

Macro AppBase_GetJustPath()
  LibBuild_BasePathJustPath
  EndMacro
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 6
; FirstLine = 3
; Folding = --
; EnableUnicode
; EnableXP