EnableExplicit

Structure BinaryBufferStruct
  hMem.i
  Blck.i
  Left.i
  RPos.i
  WPos.i
  EndStructure

Procedure.i BinaryBuffer_Create(BlockSize = $2000)
  Define.i xResult
  Define *xType1.BinaryBufferStruct

  *xType1 = MemAllocNC(SizeOf(BinaryBufferStruct))
  If *xType1
    *xType1\hMem = MemAllocNC(BlockSize + 4) ; 4 extrabytes for safety
    If *xType1\hMem
      With *xType1
        \Blck = BlockSize
        \Left = BlockSize
        \WPos = \hMem
        \RPos = \hMem
        EndWith
      xResult = *xType1
      EndIf
    If Not xResult
      MemFree(*xType1)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i BinaryBuffer_Discard(*hBinWrBuffer.BinaryBufferStruct)
  If *hBinWrBuffer
    If *hBinWrBuffer\hMem
      MemFree(*hBinWrBuffer\hMem)
      EndIf
    MemFree(*hBinWrBuffer)
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 38
; FirstLine = 12
; Folding = -
; EnableUnicode
; EnableXP