EnableExplicit

LibBuild_Include(BitmapStretchDrawEx)

Procedure.i BitmapStretchCopyEx(hBmpSource.i, NewWidth.i, NewHeight.i, ReservedScaleMode.i)
  Define.i xResult
  ;Define.i xLongA1(6)
  Define.BITMAP xType1
  Define.i hDC
  Define.i hBmp
  Define.i hBmpOld
  Define.i MLeft
  Define.i MTop
  Define.i MWidth
  Define.i MHeight

  If GetObject_(hBmpSource, SizeOf(BITMAP), @xType1)
    If xType1\bmWidth > 0 And xType1\bmHeight > 0
      If NewWidth = 0
        NewWidth = xType1\bmWidth
        ElseIf NewWidth = -1
        NewWidth = -xType1\bmWidth
        EndIf
      If NewHeight = 0
        NewHeight = xType1\bmHeight
        ElseIf NewHeight = -1
        NewHeight = -xType1\bmHeight
        EndIf
      If NewWidth And NewHeight
        hDC = GetDC_(0)
        If hDC
          MWidth = NewWidth
          If NewWidth < 0
            MLeft = -NewWidth
            MWidth = -NewWidth
            EndIf
          MHeight = NewHeight
          If NewHeight < 0
            MTop = -NewHeight
            MHeight = -NewHeight
            EndIf
          hBmp = CreateCompatibleBitmap_(hDC, MWidth, MHeight)
          ReleaseDC_(0, hDC)
          If hBmp
            hDC = CreateCompatibleDC_(0)
            If hDC
              hBmpOld = SelectObject_(hDC, hBmp)
              If hBmpOld
                If BitmapStretchDrawEx(hDC, hBmpSource, MLeft, MTop, NewWidth, NewHeight, ReservedScaleMode)
                  xResult = hBmp
                  EndIf
                SelectObject_(hDC, hBmpOld)
                EndIf
              DeleteDC_(hDC)
              EndIf
            If xResult = 0
              DeleteObject_(hBmp)
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 4
; FirstLine = 1
; Folding = -
; EnableUnicode
; EnableXP