EnableExplicit

LibBuild_Include(DateIsGregYear)

Procedure.i DateTripleToLong(xYear.i, xMonth.i, xDay.i)
  EnableASM
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      MOV rax, xYear
      ;xYear - 1
      DEC rax
    
      ;xLong1 = Fix(xYear / 400) * 146097
      XOR rdx, rdx
      MOV r8, 400
      DIV r8
      MOV r9, rdx
      MOV r8, 146097
      MUL r8
      MOV rcx, rax
      ;xYear = xYear % 400
      MOV rax, r9
      ;xLong1 + Fix(xYear / 100) * 36524
      MOV r8, 100
      DIV r8
      MOV r9, rdx
      MOV r8, 36524
      MUL r8
      ADD rcx, rax
      ;xYear % 100
      MOV rax, r9
      ;xLong1 + Fix(xYear / 4) * 1461
      SHR rax, 2
      MOV r8, 1461
      MUL r8
      ADD rcx, rax
    ;  xYear & 3
      MOV rax, r9
    ;  xLong1 + xYear * 365
      AND rax, 3
      MOV r8, 365
      MUL r8
      ADD rcx, rax
      ADD rcx, xDay

      ;MOV xLong1, rcx
      MOV rax, xMonth
      DEC rax
      ;MOVZX rdx, word [MonthDataInfo + rax * 2]
      ;SHL rax, 1
      ;ADD rax, MonthDataInfo
      MOV rdx, MonthDataInfo
      MOVZX rdx, word [rdx + rax * 2]
      ;MOVZX rdx, word [rax]
CompilerIf #True
      ADD rcx, rdx
      MOV xDay, rcx
CompilerEndIf
      CompilerElse
      MOV eax, xYear
      ;xYear - 1
      DEC eax
    
      PUSH ebp
      PUSH ebx
      ;xLong1 = Fix(xYear / 400) * 146097
      XOR edx, edx
      MOV ebp, 400
      DIV ebp
      MOV ebx, edx
      MOV ebp, 146097
      MUL ebp
      MOV ecx, eax
      ;xYear = xYear % 400
      MOV eax, ebx
      ;xLong1 + Fix(xYear / 100) * 36524
      MOV ebp, 100
      DIV ebp
      MOV ebx, edx
      MOV ebp, 36524
      MUL ebp
      ADD ecx, eax
      ;xYear % 100
      MOV eax, ebx
      ;xLong1 + Fix(xYear / 4) * 1461
      SHR eax, 2
      MOV ebp, 1461
      MUL ebp
      ADD ecx, eax
    ;  xYear & 3
      MOV eax, ebx
POP ebx
    ;  xLong1 + xYear * 365
      AND eax, 3
      MOV ebp, 365
      MUL ebp
POP ebp
      ADD ecx, eax
      ADD ecx, xDay

      ;MOV xLong1, ecx
      MOV eax, xMonth
      DEC eax
      MOVZX edx, word [MonthDataInfo + eax * 2]
      ADD ecx, edx
      MOV xDay, ecx
      CompilerEndIf
    DisableASM

  If xMonth > 2
    If DateIsGregYear(xYear)
      xDay + 1
      EndIf
    EndIf

  ProcedureReturn xDay

  EnableASM
    !MonthDataInfo:
    !DW   0
    !DW  31
    !DW  59
    !DW  90
    !DW 120
    !DW 151
    !DW 181
    !DW 212
    !DW 243
    !DW 273
    !DW 304
    !DW 334
    DisableASM  
  EndProcedure

Procedure FastValIntUA(*Mem, xLen.i = -1)
CompilerIf 0
EnableASM
  MOV eax, *Mem
  MOV ecx, xLen
  PUSH esi ; str mem pointer
  PUSH ebx ; temp
  PUSH ebp ; 10 multiplier
  MOV esi, eax
  XOR ebx, ebx ; so only bl valid, for adding
  XOR eax, eax ; result
  MOV ebp, 10

!FastValIntUA_Loop:
  MOV bl, [esi]
  OR bl, bl
  JZ FastValIntUA_Exit
  CMP bl, 48
  JB FastValIntUA_Fail
  CMP bl, 59
  JA FastValIntUA_Fail

  SUB bl, 48
  MUL ebp
  ADD eax, ebx
  INC esi
  DEC ecx
  JZ FastValIntUA_Exit
  JMP FastValIntUA_Loop  

  !FastValIntUA_Fail:
  XOR eax, eax
  !FastValIntUA_Exit:

  POP ebp
  POP ebx
  POP esi

  MOV xLen, eax
DisableASM  
  ProcedureReturn xLen
CompilerEndIf
  EndProcedure

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 113
; FirstLine = 87
; Folding = -
; EnableAsm
; EnableXP
; EnablePurifier