EnableExplicit

Declare GetCursorPosPX(*ptrPoint)

Macro GetCursorPosPX_DPIUnaware()
  Procedure GetCursorPosPX(*ptrPoint)
    GetCursorPos_(*ptrPoint)
    EndProcedure
  EndMacro

Macro GetCursorPosPX_DPIAware()
  Procedure GetCursorPosPX(*ptrPoint)
    Define.i xLong1
  
    xLong1 = GetModuleHandle_("user32.dll")
    If xLong1
      xLong1 = GetProcAddress(xLong1, "GetPhysicalCursorPos")
      If xLong1
        CallFunctionFast(xLong1, *ptrPoint)
        ProcedureReturn
        EndIf
      EndIf
    GetCursorPos_(*ptrPoint)
    EndProcedure
  EndMacro
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableUnicode
; EnableXP