EnableExplicit

#MDT_Effective_DPI  = 0
;#MDT_Angular_DPI    = 1
;#MDT_Raw_DPI        = 2
;#MDT_Default        = #MDT_Effective_DPI

Procedure GetWindowDPIScalingFloatMul(hWnd, *DPIScaleX, *DPIScaleY)
  Define.f ScaleX
  Define.f ScaleY
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i hMonitor

  ScaleX = 1
  ScaleY = 1
  xLong1 = GetDC_(0)
  If xLong1
    ScaleX = GetDeviceCaps_(xLong1, 88) / 96
    ScaleY = GetDeviceCaps_(xLong1, 90) / 96
    ReleaseDC_(0, xLong1)
    EndIf

  xLong1 = GetModuleHandle_(@"user32.dll")
  If xLong1
    If hWnd
      xLong2 = GetProcAddress(xLong1, "MonitorFromWindow")
      If xLong2
        hMonitor = CallFunctionFast(xLong2, hWnd, #MONITOR_DEFAULTTONEAREST)
        EndIf
      Else
      xLong2 = GetProcAddress(xLong1, "MonitorFromPoint")
      If xLong2
        hMonitor = CallFunctionFast(xLong2, 0, 0, #MONITOR_DEFAULTTONEAREST)
        EndIf
      EndIf
    If hMonitor
      xLong2 = GetProcAddress(xLong1, "GetDpiForMonitor")
      If xLong2
        xLong1 = 0
        If CallFunctionFast(xLong2, hMonitor, #MDT_Effective_DPI, @xLong1, @xLong3) = #S_OK
          If xLong1 And xLong2
            ScaleX = xLong1 / 96
            ScaleY = xLong2 / 96
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  PokeF(*DPIScaleX, ScaleX)
  PokeF(*DPIScaleY, ScaleY)
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 35
; FirstLine = 24
; Folding = -
; Executable = CleanupEmptyDirs.exe
; CommandLine = "T:\GameMusicRipp\2011\Alien Breed 2 - Assault"
; CompileSourceDirectory