﻿EnableExplicit

LibBuild_Include(LoadResEx_WEMF_MultiOS)
LibBuild_Include(BitmapFromWEMF)

Procedure.i LoadResEx_ImageBitmapWEMF_MultiOS(ResID.i, SizeX.i, SizeY.i, BgColor.i, *ColorFixer)
  Define.i xResult
  Define.i hMeta

  hMeta = LoadResEx_WEMF_MultiOS(ResID)
  If hMeta
    xResult = BitmapFromWEMF(hMeta, SizeX.i, SizeY.i, BgColor.i, *ColorFixer)
    CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
      DeleteEnhMetaFile_(hMeta)
      CompilerElse
      DeleteMetaFile_(hMeta)
      CompilerEndIf
    EndIf
  CompilerIf Defined(LibBuild_LoadResEx_Image_MultiOS_Included, #PB_Constant)
    If Not xResult
      xResult = LoadResEx_Image_MultiOS(ResID, 0, 0)
      EndIf
    CompilerEndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 18
; FirstLine = 2
; Folding = -
; EnableUnicode
; EnableXP