﻿EnableExplicit

LibBuild_CheckPriority(LoadResEx_WindowIconWEMF_MultiOS)
LibBuild_Include(LoadResEx_WindowIcon_Discard)

Procedure LoadResEx_WindowIcon_MultiOS(hWnd.i, *ResIDBig, *ResIDSmall, *ptrTrayToUpdate.NOTIFYICONDATA = 0)
  Define.i xLong1
  Define.i xLong2
  CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
    Define.i xLong3
    CompilerEndIf
  Define.i xLong4
  Define.i xLong5

  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    If IsMinWindowsVista
      xLong1 = LoadImage_(hInstance, *ResIDSmall + 1, 1, 16, 16, 0)
      xLong2 = LoadImage_(hInstance, *ResIDBig + 1, 1, 32, 32, 0)
      CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
        If *ptrTrayToUpdate And xLong1
          xLong3 = LoadImage_(hInstance, *ResIDSmall + 1, 1, 16, 16, 0)
          EndIf
        CompilerEndIf
      EndIf
    If Not xLong1
      xLong1 = LoadImage_(hInstance, *ResIDSmall, 1, 16, 16, 0)
      CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
        If *ptrTrayToUpdate And xLong1
          xLong3 = LoadImage_(hInstance, *ResIDSmall, 1, 16, 16, 0)
          EndIf
        CompilerEndIf
      EndIf
    If Not xLong2
      xLong2 = LoadImage_(hInstance, *ResIDBig, 1, 32, 32, 0)
      EndIf
    CompilerElseIf #PB_Compiler_Unicode
    If IsHighColor
      If IsMinWindowsVista
        xLong4 = 5
        xLong5 = 5
        ElseIf IsMinWindowsXP
        xLong4 = 4
        xLong5 = 4
        ElseIf IsMinWindows2000
        xLong4 = 3
        xLong5 = 3
        Else
        xLong4 = 2
        EndIf
      While xLong4 > 1 And Not (xLong1 Or xLong2)
        xLong1 = LoadImage_(hInstance, *ResIDSmall + xLong4, 1, 16, 16, 0)
        xLong2 = LoadImage_(hInstance, *ResIDBig + xLong4, 1, 32, 32, 0)
        CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
          If *ptrTrayToUpdate And xLong1 And xLong5
            xLong3 = LoadImage_(hInstance, *ResIDSmall + xLong4, 1, 16, 16, 0)
            EndIf
          CompilerEndIf
        xLong4 - 1
        Wend
      EndIf

    If IsMinWindows2000
      If Not xLong1
        xLong1 = LoadImage_(hInstance, *ResIDSmall + 1, 1, 16, 16, 0)
        CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
          If *ptrTrayToUpdate And xLong1
            xLong3 = LoadImage_(hInstance, *ResIDSmall + 1, 1, 16, 16, 0)
            EndIf
          CompilerEndIf
        EndIf
      If Not xLong2
        xLong2 = LoadImage_(hInstance, *ResIDBig, 1 + 1, 32, 32, 0)
        EndIf
      EndIf

    If Not xLong1
      xLong1 = LoadImage_(hInstance, *ResIDSmall, 1, 16, 16, 0)
CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
      If *ptrTrayToUpdate And xLong1
        xLong3 = LoadImage_(hInstance, *ResIDSmall, 1, 16, 16, 0)
        EndIf
      ElseIf Not xLong3
      xLong3 = LoadImage_(hInstance, *ResIDSmall, 1, 16, 16, 0)
CompilerEndIf
      EndIf
    If Not xLong2
      xLong2 = LoadImage_(hInstance, *ResIDBig, 1, 32, 32, 0)
      EndIf
    CompilerElse
    If IsHighColor
      If IsMinWindowsME
        xLong4 = 4
        ElseIf IsMinWindows98
        xLong4 = 3
        ;xLong4 = 0
        Else
        xLong4 = 2
        ;xLong4 = 0
        EndIf
      While xLong4 > 1 And Not (xLong1 Or xLong2)
        xLong1 = LoadImage_(hInstance, *ResIDSmall + xLong4, 1, 16, 16, 0)
        xLong2 = LoadImage_(hInstance, *ResIDBig + xLong4, 1, 32, 32, 0)
        CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
          If *ptrTrayToUpdate And xLong1 And IsMinWindowsME
            xLong3 = LoadImage_(hInstance, *ResIDSmall + xLong4, 1, 16, 16, 0)
            EndIf
          CompilerEndIf
        xLong4 - 1
        Wend
      EndIf

    If IsMinWindowsME
      If Not xLong1
        xLong1 = LoadImage_(hInstance, *ResIDSmall + 1, 1, 16, 16, 0)
        CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
          If *ptrTrayToUpdate And xLong1
            xLong3 = LoadImage_(hInstance, *ResIDSmall + 1, 1, 16, 16, 0)
            EndIf
          CompilerEndIf
        EndIf
      If Not xLong2
        xLong2 = LoadImage_(hInstance, *ResIDBig, 1 + 1, 32, 32, 0)
        EndIf
      EndIf

    If Not xLong1
      xLong1 = LoadImage_(hInstance, *ResIDSmall, 1, 16, 16, 0)
      CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
        If *ptrTrayToUpdate And xLong1
          xLong3 = LoadImage_(hInstance, *ResIDSmall, 1, 16, 16, 0)
          EndIf
        CompilerEndIf
CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
      ElseIf Not xLong3
      xLong3 = LoadImage_(hInstance, *ResIDSmall, 1, 16, 16, 0)
CompilerEndIf
      EndIf
    If Not xLong2
      xLong2 = LoadImage_(hInstance, *ResIDBig, 1, 32, 32, 0)
      EndIf
    CompilerEndIf

  If xLong1
    xLong1 = SendMessage_(hWnd, $80, 0, xLong1)
    If xLong1
      DestroyIcon_(xLong1)
      EndIf
    EndIf

  If xLong2
    xLong2 = SendMessage_(hWnd, $80, 1, xLong2)
    If xLong2
      DestroyIcon_(xLong2)
      EndIf
    EndIf

  CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
    If *ptrTrayToUpdate And xLong3
      xLong1 = *ptrTrayToUpdate\hIcon
      *ptrTrayToUpdate\hIcon = xLong3
      Shell_NotifyIcon(1, *ptrTrayToUpdate)
      DestroyIcon_(xLong1)
      EndIf
    CompilerEndIf
  EndProcedure  

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 8
; FirstLine = 5
; Folding = ---
; EnableUnicode
; EnableXP