EnableExplicit

Procedure.i SetVolumeMountPoint(lpszVolumeMountPoint.s, lpszVolumeNameGUID.s)
  Define.i xLong1
  CompilerIf #PB_Compiler_Unicode
    CompilerElse
    Define *Mem
    CompilerEndIf

  If Mid(lpszVolumeMountPoint, 2, 1) = ":"
    If Not Right(lpszVolumeMountPoint, 1) = "\"
      lpszVolumeMountPoint + "\"
      EndIf
    xLong1 = GetModuleHandle_("kernel32.dll")
    If xLong1
      xLong1 = GetProcAddress(xLong1, "SetVolumeMountPointW")
      If xLong1
        CompilerIf #PB_Compiler_Unicode
          xLong1 = CallFunctionFast(xLong1, @lpszVolumeMountPoint, @lpszVolumeNameGUI)
          CompilerElse
          *Mem = AllocateMemory(Len((lpszVolumeNameGUID) + 1) << 1)
          If *Mem
            PokeS(*ptrTemp, lpszVolumeMountPoint, -1, #PB_Unicode)
            PokeS(*Mem, lpszVolumeNameGUID, -1, #PB_Unicode)
            xLong1 = CallFunctionFast(xLong1, *ptrTemp, *Mem)
;Debug(GetLastError_())
;MessageRequester("Mount", Str(GetLastError_()))
            FreeMemory(*Mem)
            EndIf
          CompilerEndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xLong1
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 26
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnablePurifier