EnableExplicit

LibBuild_Include(SoundSchemes_ReadInt)
LibBuild_Include(BinaryBuffer_IsOK)

Procedure.i SoundSchemes_ReadAll(SchemeName.s)
  Define *BF
  Define.i hKey
  Define.i xCnt1
  Define.i xFail
  Define.s xChar1

  *BF = BinaryBuffer_Create()
  If *BF
    SchemeName = "\" + SchemeName
    If RegOpenKeyEx_($80000001, @"AppEvents\Schemes\Apps", 0, 8, @hKey)
      xFail = #True
      Else
      Repeat
        xChar1 = RegEnumKey(hKey, xCnt1)
        If Not Len(xChar1)
          Break
          EndIf
        If Not SoundSchemes_ReadInt(*BF, SchemeName, xChar1)
          xFail = #True
          EndIf
        xCnt1 + 1
        Until xFail
      RegCloseKey_(hKey)
      EndIf
    If xFail Or Not BinaryBuffer_IsOK(*BF)
      BinaryBuffer_Discard(*BF)
      *BF = 0
      EndIf
    EndIf
  ProcedureReturn *BF
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableUnicode
; EnableXP