EnableExplicit

LibBuild_Include(SoundSchemes_Core)
LibBuild_Include(RegEnumKey)
LibBuild_Include(BinaryBuffer_WriteMemEx)
LibBuild_Include(BinaryBuffer_WriteStringLP)

Procedure.i SoundSchemes_ReadInt(*BF, SchemeNameEx.s, ApplicationName.s)
  Define.i hKey1
  Define.i xCnt1
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i hKey2
  Define.i xFail
  Define.i xResult
  Define *Mem
  Define.s xChar1
  Define.s xChar2

  xChar1 = "AppEvents\Schemes\Apps\" + ApplicationName
  If Not RegOpenKeyEx_($80000001, @xChar1, 0, 8, @hKey1)
    ApplicationName = ApplicationName + "\"
    Repeat
      xChar1 = RegEnumKey(hKey1, xCnt1)
      If Not Len(xChar1)
        Break
        EndIf
      xChar2 = "AppEvents\Schemes\Apps\" + ApplicationName + xChar1 + SchemeNameEx
      If RegOpenKeyEx_($80000001, @xChar2, 0, 1, @hKey2)
        xFail = #True
        Else
        xLong1 = 0
        xLong2 = 0
        xLong3 = RegQueryValueEx_(hKey2, 0, 0, @xLong1, *ptrTemp, @xLong2)
        If xLong3 = #ERROR_MORE_DATA And xLong2
          BinaryBuffer_WriteStringLP(*BF, ApplicationName + xChar1)
          BinaryBuffer_WriteMemExI(*BF, xLong1)
          BinaryBuffer_WriteMemExI(*BF, xLong2)
          *Mem = BinaryBuffer_WriteMemEx(*BF, 0, xLong2)
          xLong3 = xLong2
          If *Mem
            If RegQueryValueEx_(hKey2, 0, 0, @xLong1, *Mem, @xLong2)
              xFail = #True
              Else
;Debug "R:" + ApplicationName + xChar1 + "=" + Str(xLong1) + "/" + Str(xLong2) + "/" + PeekS(*Mem)
              If xLong2 = xLong3
                xResult = #True
                Else
                xFail = #True
                EndIf
              EndIf
            Else
            xFail = #True
            EndIf
          ElseIf xLong3
;Debug "Fail1"
          xFail = #True
          Else
          BinaryBuffer_WriteStringLP(*BF, ApplicationName + xChar1)
          BinaryBuffer_WriteMemExI(*BF, xLong1)
          BinaryBuffer_WriteMemExI(*BF, xLong2)
;Debug "E:" + ApplicationName + xChar1 + "=" + Str(xLong1) + "/" + Str(xLong2)
          EndIf
        RegCloseKey_(hKey2)
        EndIf
      xCnt1 + 1
      Until xFail
    RegCloseKey_(hKey1)
    EndIf
  If xFail
    xResult = #False
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 28
; FirstLine = 13
; Folding = -
; EnableUnicode
; EnableXP