﻿EnableExplicit

LibBuild_Include(TxtFileWriter_Main)
LibBuild_Include(TxtFileReader_FromFile)

Procedure.i TxtFileWriter_AppendFileEx(Filename.s, DefaultEncoding.i, DefaultByteOrderMark.i)
  Define.i xLong1
  Define *xType1.TxtFileWriteStruct

  *xType1 = MemAllocNC(SizeOf(TxtFileWriteStruct))
  If *xType1
    *xType1\hFile = TxtFileReader_OpenEx(Filename, @*xType1\Encoding, @xLong1, #True)
    If *xType1\hFile = -1
      MemFree(*xType1)
      *xType1 = 0
      If GetFileAttributes(Filename) = -1
        *xType1 = TxtFileWriter_CreateFileEx(Filename, DefaultEncoding, DefaultByteOrderMark)
        EndIf
      EndIf
    EndIf
  ProcedureReturn *xType1
  EndProcedure

CompilerIf #PB_Compiler_Unicode
  Macro TxtFileWriter_AppendFile(Filename)
    TxtFileWriter_AppendFileEx(Filename, #CP_WINUNICODE, #True)
    EndMacro
  CompilerElse
  Macro TxtFileWriter_AppendFile(Filename)
    TxtFileWriter_AppendFileEx(Filename, #CP_ACP, #False)
    EndMacro
  CompilerEndIf

; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 15
; FirstLine = 3
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory