EnableExplicit

LibBuild_CheckPriority(WinSock_Connect)

Procedure.i WinSock_GetHostByName(xHostname.s)
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    Define.hostent *xType1
    Define.i xLong1

    CompilerIf #PB_Compiler_Unicode
      PokeS(*ptrTemp, xHostname, -1, #PB_Ascii)
      *xType1 = gethostbyname_(*ptrTemp)
      CompilerElse
      *xType1 = gethostbyname_(@xHostname)
      CompilerEndIf
    If *xType1
      If *xType1\h_addr_list
        xLong1 = PeekI(*xType1\h_addr_list)
        If xLong1
          xLong1 = PeekL(xLong1)
          EndIf
        EndIf
      EndIf
    ProcedureReturn xLong1
    CompilerElse
    Define.i xLong1
    Define.i xLong2

    CompilerIf #PB_Compiler_Unicode
      PokeS(*ptrTemp, xHostname, -1, #PB_Ascii)
      xLong1 = gethostbyname_(*ptrTemp)
      CompilerElse
      xLong1 = gethostbyname_(@xHostname)
      CompilerEndIf

    If xLong1
      If (GetVersion_() & $80000000)
        xLong1 = PeekL(xLong1 + 16)
        Else
        xLong1 = PeekL(xLong1 + 12)
        If xLong1
          xLong1 = PeekL(xLong1)
          EndIf
        EndIf
      If xLong1
        ProcedureReturn PeekL(xLong1)
        EndIf
      EndIf
    CompilerEndIf
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 7
; Folding = -
; EnableUnicode
; EnableXP