﻿EnableExplicit

#CalaymClassNameMsg = "CalaymInterMsgClass101"
#CalaymClassTitleMsg = "Calaym"
#CalaymClassForm = "CalaymPlayerWindow"
#CalaymClassStaticWhiteDC = "CalaymUniWhiteBkControl"
#CalaymClassSplitterTH = "CalaymDirListSplitterVrt"
#CalaymClassSplitterLW = "CalaymDirListSplitterHrz"
#CalaymClassSplitterMoveTH = "CalaymDirListSplitterVrtMoving"
#CalaymClassSplitterMoveLW = "CalaymDirListSplitterHrzMoving"
#CalaymClassToolTip = "CalaymToolTip"


;0-5=defs
#xStaticIcons_Def0 = 0
#xStaticIcons_Def1 = 1
#xStaticIcons_Def2 = 2
#xStaticIcons_Def3 = 3
#xStaticIcons_Def4 = 4
#xStaticIcons_Def5 = 5
#xStaticIcons_Volume = 6
#xStaticIcons_RepMode = 7
#xStaticIcons_TimerInd = 8
;;;#xStaticIcons_MP3FormatIcon = 9
#xStaticIcons_Anim = 9
#xStaticIcons_LastBMP = 9
Global Dim xStaticIconsBMP.i(#xStaticIcons_LastBMP)
#xStaticIcons_Spectrum = 10
#xStaticIcons_DirList = 11
#xStaticIcons_CurSong = 12
#xStaticIcons_CurSongPos = 13
#xStaticIcons_Tags = 14
#xStaticIcons_ShowIR = 15
#xStaticIcons_Last = 15
#xStaticIcons_ToolTip = 16
#xStaticIcons_BAR = 17
Global DPISIconSizeX.i
Global DPISIconSizeY.i
Global Dim *FormatIconBMP(6)
;Global Dim FormatIconLen(6)

Global Dim xStaticIconsHWnd.i(#xStaticIcons_BAR)
Global Dim xStaticIconsToolTip.s(#xStaticIcons_Tags, 1)
Global Dim xListHWnd.i(2)
Global MainFormIsSplitterMovingTH.i
Global MainFormIsSplitterMovingLW.i
Global CurShownToolTip.i
Global ToolTipInitTime.i
Global ToolTipDelay.i
#TTSplitter = Chr(13)
#TTSplitterTab = Chr(9)
#TTSplitter2 = #TTSplitter ;+ TTSplitter
Global hFontTTip.i
Global CurShownToolTip_SpHeight.i
Global CurShownToolTip_SpKeyPre.i
Global CurShownToolTip_SpKey.i
Global CurShownToolTip_TotalWidthX.i
#TTSpaceLeft = 5
;#TTSpaceLeftD = TTSpaceLeft * 2
#TTSpaceTop = 3
#TTSpaceTopD = #TTSpaceTop * 2
Global SysColor5.i
Global SysColor23.i
Global SysColor24.i
Global ScrollComboWidth.i
Global hThemeComboDropButtons.i
#FillSysColorBack = 5 + 1 ;$F& + 1
#FillSysColorFore = 13 + 1
#FillSysColorFace = 15 + 1 ;$F& + 1
#FillSysColorSunkenD = 16 + 1 ;$F& + 1
#FillSysColorSunkenW = 20 + 1 ;$F& + 1
Global FormatIconBackSunken.i
Global FormatIconBackSunkenD.i
Global FormatIconBackSunkenW.i
Global FormatIconFore.i
Global MP3FormatBitmap.i
Global MainDPIScaleX.f
Global MainDPIScaleY.f
Global xVolMTbWidth.i
Global xVolTotWidth.i
Global FormatIconCurQualColor.i

Procedure DrawWhiteDCDropButton(hWnd.i, IDUpOrDown.i, IsDown.i)
  Define.i xLong1
  Define.i xLong2
  Define.RECT xType1
  
  If GetClientRect_(hWnd, @xType1)
    xLong1 = GetDC_(hWnd)
    If xLong1
      xType1\left = xType1\Right - ScrollComboWidth ;3
      If hThemeComboDropButtons
        xLong2 = IDUpOrDown * 4 + 1 + IsDown * 2
        If IsThemeBackgroundPartiallyTransparent(hThemeComboDropButtons, 1, xLong2)
          DrawThemeParentBackground(hWnd, xLong1, @xType1)
          EndIf
        DrawThemeBackground(hThemeComboDropButtons, xLong1, 1, xLong2, @xType1, 0)
        Else
        DrawFrameControl_(xLong1, @xType1, 3, IsDown * $200 + IDUpOrDown) ;(ID & $1))
        EndIf
      ReleaseDC_(hWnd, xLong1)
      EndIf
    EndIf
  EndProcedure


Procedure CalcToolTip()
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.s xChar1
  Define.POINT xType1
  Define.POINT xType2
  Define.RECT xType3
  Define.i xCount
  
  xChar1 = xStaticIconsToolTip(CurShownToolTip, 0) + #TTSplitter
  SelectObject_(xSharedDC, hFontTTip)
  Repeat
    xLong1 = FindString(xChar1, #TTSplitter)
    If xLong1 = 0
      Break
      EndIf
    If xCount = 1
      xType3\Bottom = xType3\Bottom + 5
      EndIf
    xCount = xCount + 1
    GetTextExtentPoint32_(xSharedDC, @xChar1, xLong1 - 1, @xType1)
    If xType1\x > xType3\Right
      xType3\Right = xType1\x
      EndIf
    xType3\Bottom = xType3\Bottom + CurShownToolTip_SpHeight
    xChar1 = Mid(xChar1, xLong1 + 1)
    ForEver
  xType3\Right = xType3\Right + #TTSpaceLeft
  
  CurShownToolTip_SpKey = 0
  If Not Len(xStaticIconsToolTip(CurShownToolTip, 1)) = 0
    ;If xCount < 2
      ;xType3\Bottom = xType3\Bottom + 5
      ;EndIf
    xType3\Bottom = xType3\Bottom + 4
    
    xChar1 = xStaticIconsToolTip(CurShownToolTip, 1) + #TTSplitter2
    If FindString(xChar1, #TAB$) = 0
      xChar1 = #TAB$ + xChar1
      EndIf
    Repeat
      xLong1 = FindString(xChar1, #TTSplitterTab)
      xLong2 = FindString(xChar1, #TTSplitter)
      If xLong1 = 0 Or xLong2 = 0 Or xLong1 > xLong2
        Break
        EndIf
      GetTextExtentPoint32_(xSharedDC, @xChar1, xLong1 - 1, @xType1)
      If xType1\x > CurShownToolTip_SpKey
        CurShownToolTip_SpKey = xType1\x
        EndIf
      xChar1 = Mid(xChar1, xLong1 + 1)
      GetTextExtentPoint32_(xSharedDC, @xChar1, xLong2 - xLong1 - 1, @xType1)
      If xType1\x > xLong3
        xLong3 = xType1\x
        EndIf
      xType3\Bottom = xType3\Bottom + CurShownToolTip_SpHeight
      xChar1 = Mid(xChar1, xLong2 - xLong1 + 1)
      ForEver
    CurShownToolTip_SpKey = CurShownToolTip_SpKeyPre + CurShownToolTip_SpKey ;+ #TTSpaceLeft
    xLong3 = xLong3 + CurShownToolTip_SpKey ;+CurShownToolTip_SpKeyPre
    If xLong3 > xType3\Right
      xType3\Right = xLong3
      EndIf
    EndIf
  
  xType3\Right = xType3\Right + #TTSpaceLeft
  CurShownToolTip_TotalWidthX = xType3\Right
  xType3\Bottom = xType3\Bottom + #TTSpaceTopD
  AdjustWindowRectEx_(@xType3, $8E800000, 0, $84)
  xType1\x = xType3\Right - xType3\left
  xType1\y = xType3\Bottom - xType3\Top
  WindowToCursorPos(xType1, xType2)
  SetWindowPos_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 0, xType2\x, xType2\y, xType1\x, xType1\y, $214)
  EndProcedure

Macro WriteToolTip_AddLine()
  xLong4 = xLong4 + 2
  MoveToEx_(xLong1, 1, xLong4, 0)
  xhPen = CreatePen_(0, 0, SysColor23)
  If xhPen
    xhPenOld = SelectObject_(xLong1, xhPen)
    LineTo_(xLong1, CurShownToolTip_TotalWidthX, xLong4)
    SelectObject_(xLong1, xhPenOld)
    DeleteObject_(xhPen)
    EndIf
  xLong4 = xLong4 + 3
  EndMacro

Procedure WriteToolTip()
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xLong4
  Define.i xLong5
  Define.i xhPen
  Define.i xhPenOld
  Define.i xCount
  Define.s xChar1
  Define.i hFontOld

  xLong1 = GetDC_(xStaticIconsHWnd(#xStaticIcons_ToolTip))
  If xLong1
    hFontOld = SelectObject_(xLong1, hFontTTip)
    SetBkColor_(xLong1, SysColor24)
    SetTextColor_(xLong1, SysColor23)
    SetBkMode_(xLong1, 1)

    xLong4 = #TTSpaceTop
    
    xChar1 = xStaticIconsToolTip(CurShownToolTip, 0) + #TTSplitter
    Repeat
      xLong2 = FindString(xChar1, #TTSplitter)
      If xLong2 = 0
        Break
        EndIf
      If xCount = 1
        WriteToolTip_AddLine()
        EndIf
      xCount = xCount + 1
      TextOut_(xLong1, #TTSpaceLeft, xLong4, @xChar1, xLong2 - 1)
      xLong4 = xLong4 + CurShownToolTip_SpHeight
      xChar1 = Mid(xChar1, xLong2 + 1)
      ForEver

    If Len(xStaticIconsToolTip(CurShownToolTip, 1))
      ;WriteToolTip_AddLine()
      xLong4 = xLong4 + 4
      xChar1 = LoadResString(1100)
      TextOut_(xLong1, #TTSpaceLeft, xLong4, @xChar1, Len(xChar1))
      
      xChar1 = xStaticIconsToolTip(CurShownToolTip, 1) + #TTSplitter ;2
      If FindString(xChar1, #TAB$) = 0
        xChar1 = #TAB$ + xChar1
        EndIf
      Repeat
        xLong2 = FindString(xChar1, #TTSplitterTab)
        xLong3 = FindString(xChar1, #TTSplitter)
        If xLong2 = 0 Or xLong3 = 0 Or xLong2 > xLong3
          Break
          EndIf
        ;If xLong2 = 0
        ;  xLong3 = xLong2
        ;  xLong2 = Len(xChar1)
        ;  EndIf
;Debug "TO1: 1, " + Str(xLong2 - 1) + " / " + Str(Len(xChar1))
        
        xLong5 = GetTextOutWidth(xLong1, Left(xChar1, xLong2 - 1))
        ;CurShownToolTip_SpKey
        ;TextOut_(xLong1, CurShownToolTip_SpKeyPre, xLong4, @xChar1, xLong2 - 1)
        TextOut_(xLong1, CurShownToolTip_SpKey - xLong5, xLong4, @xChar1, xLong2 - 1)
;Debug "TO2: " + Str(xLong2 + 1) + "/" + Str(Len(xChar1))
        CompilerIf #PB_Compiler_Unicode
          TextOut_(xLong1, CurShownToolTip_SpKey, xLong4, @xChar1 + (xLong2 << 1), xLong3 - xLong2 - 1)
          CompilerElse
          TextOut_(xLong1, CurShownToolTip_SpKey, xLong4, @xChar1 + xLong2, xLong3 - xLong2 - 1)
          CompilerEndIf
        xLong4 = xLong4 + CurShownToolTip_SpHeight
        xChar1 = Mid(xChar1, xLong3 + 1)
        ForEver
      EndIf
    SelectObject_(xLong1, hFontOld)
    ReleaseDC_(xStaticIconsHWnd(#xStaticIcons_ToolTip), xLong1)
    EndIf
  EndProcedure

Procedure SetToolTip(Index.i, xChar1.s, xChar2.s)
  Define.RECT xType1

  If Not (xStaticIconsToolTip(Index, 0) = xChar1 And xStaticIconsToolTip(Index, 1) = xChar2)
    xStaticIconsToolTip(Index, 0) = xChar1
    xStaticIconsToolTip(Index, 1) = xChar2

    If ToolTipInitTime = -1 And Index = CurShownToolTip
      CalcToolTip()
      ;MainForm_EraseBackgroundTT()
      Index = GetDC_(xStaticIconsHWnd(#xStaticIcons_ToolTip))
      If Index
        GetClientRect_(xStaticIconsHWnd(#xStaticIcons_ToolTip), @xType1)
        FillRect_(Index, @xType1, 25)
        ReleaseDC_(xStaticIconsHWnd(#xStaticIcons_ToolTip), Index)
        EndIf
      SendMessage_(xStaticIconsHWnd(#xStaticIcons_ToolTip), $F, 0, 0)
      EndIf
    EndIf
  EndProcedure

Procedure.i MainForm_MeasureAlignVolFaderA(xVolPos.i)
  ;Debug Hex(xVolume) + " -> " + Str(SignedLowerWord(xVolume))

  xVolPos - (xVolMTbWidth >> 1)
  If xVolPos < 0
    xVolPos = 0
    ElseIf xVolPos > xVolTotWidth - xVolMTbWidth - 1
    xVolPos = xVolTotWidth - xVolMTbWidth - 1
    EndIf
  ProcedureReturn Int((xVolPos * 255) / (xVolTotWidth - xVolMTbWidth - 1))
  EndProcedure

Procedure MainForm_DrawVolFaderA(xVolume.i)
  Define.i FaderPos
  Define.i xBmp
  Define.i xBmpOld
  Define.i xhPen
  Define.i xhPen2
  Define.i xhPenOld
  Define.RECT xType1
  Define.i xScWidth

  xBmp = CreateCompatibleBitmapX(xVolTotWidth, 16 * MainDPIScaleY)
  If xBmp
    xBmpOld = SelectObject_(xSharedDC, xBmp)
    xType1\Right = xVolTotWidth
    xType1\Bottom = 16 * MainDPIScaleY
    FillRect_(xSharedDC, @xType1, #FillSysColorFace)
    ;FaderPos = MulDiv_(32, xVolume, 255)
    FaderPos = MulDiv_(xVolTotWidth - xVolMTbWidth, xVolume, 255)
    MoveToEx_(xSharedDC, 0, 12 * MainDPIScaleY - 1, 0)
    xhPen = CreatePen_(0, 0, FormatIconBackSunkenD)
    If xhPen
      xhPenOld = SelectObject_(xSharedDC, xhPen)
      ;LineTo_(xSharedDC, 38, 3)
      LineTo_(xSharedDC, xVolTotWidth - 2, 3 * MainDPIScaleY)
      ;SetPixel_(xSharedDC, 38, 3, FormatIconBackSunkenD)
      SetPixel_(xSharedDC, xVolTotWidth - 2, 3 * MainDPIScaleY, FormatIconBackSunkenD)
      MoveToEx_(xSharedDC, 0, 12 * MainDPIScaleY, 0)
      xhPen2 = CreatePen_(0, 0, FormatIconBackSunkenW)
      If xhPen2
        SelectObject_(xSharedDC, xhPen2)
        LineTo_(xSharedDC, xVolTotWidth, 12 * MainDPIScaleY)
        MoveToEx_(xSharedDC, xVolTotWidth - 1, 3 * MainDPIScaleY, 0)
        LineTo_(xSharedDC, xVolTotWidth - 1, 12 * MainDPIScaleY)
        SelectObject_(xSharedDC, xhPen)
        DeleteObject_(xhPen2)
        EndIf
      xType1\left = FaderPos
      xType1\Right = xType1\left + xVolMTbWidth
      FillRect_(xSharedDC, @xType1, #FillSysColorSunkenW)
      xType1\left + 1
      xType1\Top = 1
      FillRect_(xSharedDC, @xType1, #FillSysColorSunkenD)
      SelectObject_(xSharedDC, xhPenOld)
      DeleteObject_(xhPen)
      EndIf
    xType1\Right - 1
    xType1\Bottom - 1;= 15 * MainDPIScaleY
    FillRect_(xSharedDC, xType1, #FillSysColorFace)
    SelectObject_(xSharedDC, xBmpOld)
    EndIf
  If xBmp
    SendMessage_(xStaticIconsHWnd(#xStaticIcons_Volume), $172, 0, xBmp)
    If xStaticIconsBMP(#xStaticIcons_Volume)
      DeleteObject_(xStaticIconsBMP(#xStaticIcons_Volume))
      EndIf
    xStaticIconsBMP(#xStaticIcons_Volume) = xBmp
    EndIf
  EndProcedure

Procedure MainForm_DrawRawWEMF_CalaymStatic_ColorFixIcon(RType.i, RSMode.i, xColor.i)
  ;Debug "Color: " + Hex(xColor)
  If xColor = $ff00ff
    xColor = FormatIconFore
    ElseIf xColor = $ffff00 Or xColor = $00ffff
    xColor = FormatIconCurQualColor
    EndIf
  ProcedureReturn xColor
  EndProcedure

;*FormatIconBmp(3), FormatIconLen(3)
;*xData, xDataLen.i
Procedure MainForm_DrawRawWEMF_MP3FormatIcon(hMeta, SizeX.i, SizeY.i, QColor.i)
  Define.i hBmp
  Define.i hBmpOld
  Define.RECT xType1
  #SaveScale = #True

  FormatIconCurQualColor = QColor
  ;xType2\Right = 20 * MainDPIScaleX
 
  xType1\Right = SizeX
  xType1\Bottom = SizeY

  hBmp = CreateCompatibleBitmapX(SizeX, SizeY)
  If hBmp
    hBmpOld = SelectObject_(xSharedDC, hBmp)
    If hBmpOld
      FillRect_(xSharedDC, @xType1, 6)
      If hMeta
        ;CompilerIf #SaveScale
        ;  BitmapFromWEMFEx(xSharedDC, hMeta, 0, 0, SizeX << 1, SizeY << 1, GetSysColor_(5), @MainForm_DrawRawWEMF_CalaymStatic_ColorFixIcon())
        ;  CompilerElse
          BitmapFromWEMFEx(xSharedDC, hMeta, 0, 0, SizeX, SizeY, GetSysColor_(5), @MainForm_DrawRawWEMF_CalaymStatic_ColorFixIcon())
        ;  CompilerEndIf
        EndIf
      SelectObject_(xSharedDC, hBmpOld)
      EndIf
    hBmpOld = MP3FormatBitmap
    MP3FormatBitmap = hBmp
    If hBmpOld
      DeleteObject_(hBmpOld)
      EndIf
    EndIf
  EndProcedure

Macro MainForm_DrawRawWEMF_MP3FormatIconL(Index, QColor)
  MainForm_DrawRawWEMF_MP3FormatIcon(*FormatIconBmp(Index), DPISIconSizeX, DPISIconSizeY, QColor)
  EndMacro

Procedure MainForm_DrawRawWEMF_CalaymStatic_ColorFix(RType.i, RSMode.i, xColor.i)
  ;Debug "Color: " + Hex(xColor)
  If xColor = $ff00ff
    xColor = FormatIconFore
    EndIf
  ProcedureReturn xColor
  EndProcedure

Procedure MainForm_DrawRawWEMF_CalaymStatic(ControlID.i, hMeta.i, IsSelected.i)
  Define.i hBmp
  Define.i hBmpOld
  Define.RECT xType1
  Define.i BgColor
  #SaveScale = #True
  #BorderMode = 0

  CompilerIf #SaveScale
    Define.i SizeXH
    Define.i SizeYH
    CompilerEndIf
  CompilerIf #BorderMode = 0
    Define.i hPen
    Define.i hPenOld
    CompilerEndIf


  ;xType2\Right = 20 * MainDPIScaleX
 
  xType1\Right = 20 * MainDPIScaleX
  xType1\Bottom = 16 * MainDPIScaleY

  hBmp = CreateCompatibleBitmapX(xType1\Right, xType1\Bottom)
  If hBmp
    hBmpOld = SelectObject_(xSharedDC, hBmp)
    If hBmpOld
      ;xLong1 = 16 ;FormatIconBack
      If IsSelected
        ;FillRect_(xSharedDC, @xType1, 17)
        BgColor = 21 ;FormatIconBackSunken
        Else
        BgColor = 16 ;FormatIconBack
        EndIf
;BgColor = 2
      FillRect_(xSharedDC, @xType1, BgColor)
      If hMeta
        CompilerIf #SaveScale
          SizeXH = 8 * Int(MainDPIScaleX)
          SizeYH = 7 * Int(MainDPIScaleY)
          BitmapFromWEMFEx(xSharedDC, hMeta, 10 * MainDPIScaleX - SizeXH, 8 * MainDPIScaleY - SizeYH, SizeXH << 1, SizeYH << 1, GetSysColor_(BgColor - 1), @MainForm_DrawRawWEMF_CalaymStatic_ColorFix())
          CompilerElse
          BitmapFromWEMFEx(xSharedDC, hMeta, 2 * MainDPIScaleX, MainDPIScaleY, Int(16 * MainDPIScaleX), Int(14 * MainDPIScaleY), GetSysColor_(BgColor - 1), @MainForm_DrawRawWEMF_CalaymStatic_ColorFix())
          CompilerEndIf
        EndIf
      If IsSelected
        CompilerIf #BorderMode = 2
          DrawFrameControl_(xSharedDC, @xType1, #DFC_BUTTON, #DFCS_BUTTONPUSH | #DFCS_HOT | #DFCS_TRANSPARENT)
          CompilerElseIf #BorderMode = 1
          BgColor = CreateSolidBrush_(GetSysColor_(16))
          If BgColor
            FrameRect_(xSharedDC, @xType1, BgColor)
            DeleteObject_(BgColor)
            EndIf
          CompilerElse
          xType1\right-1
          xType1\bottom-1
          hPen = CreatePen_(#PS_SOLID, 1, FormatIconBackSunkenD)
          If hPen
            hPenOld = SelectObject_(xSharedDC, hPen)
            If hPenOld
              MoveToEx_(xSharedDC, 0, xType1\bottom, 0)
              LineTo_(xSharedDC, 0, 0)
              LineTo_(xSharedDC, xType1\right, 0)
              SelectObject_(xSharedDC, hPenOld)
              EndIf
            DeleteObject_(hPen)
            EndIf
          hPen = CreatePen_(#PS_SOLID, 1, FormatIconBackSunkenW)
          If hPen
            hPenOld = SelectObject_(xSharedDC, hPen)
            If hPenOld
              MoveToEx_(xSharedDC, 0, xType1\bottom, 0)
              LineTo_(xSharedDC, xType1\right, xType1\bottom)
              LineTo_(xSharedDC, xType1\right, 0)
              SetPixel_(xSharedDC, xType1\right, 0, FormatIconBackSunkenW)
              SelectObject_(xSharedDC, hPenOld)
              EndIf
            DeleteObject_(hPen)
            EndIf
          CompilerEndIf
        EndIf
        ;FrameRect_(xSharedDC, xType1, 
      SelectObject_(xSharedDC, hBmpOld)
      EndIf
    
    SendMessage_(xStaticIconsHWnd(ControlID), $172, 0, hBmp)
    If xStaticIconsBMP(ControlID)
      DeleteObject_(xStaticIconsBMP(ControlID))
      EndIf
    xStaticIconsBMP(ControlID) = hBmp
    EndIf
  EndProcedure

Procedure MainForm_EraseBackground(hWnd.i)
  Define.i hDC
  Define.RECT xType1
  
  If GetClientRect_(hWnd, @xType1)
    hDC = GetDC_(hWnd)
    If hDC
      FillRect_(hDC, @xType1, #FillSysColorBack)
      ReleaseDC_(hWnd, hDC)
      EndIf
    EndIf
  EndProcedure

Procedure.i GetQualityStreamRGB(*xType1.ctSSLayerSongInfoBase)
  Define.i xResult
  Define.f xSingle1
  
  If *xType1\Format_VBR
    xSingle1 = 0.15
    EndIf

  xSingle1 = (0.5 + *xType1\Format_Frequency / 22050 * 0.25) * (Sqr(*xType1\Format_Channels) - 0.4) * *xType1\Format_BitRate / 224000 * (1 + xSingle1) * *xType1\Format_QualityMulti
  
  If xSingle1 >= 1
    xResult = $00A000
    ElseIf xSingle1 >= 0.75
    xResult = (1 - xSingle1) * $2800000
    xResult = (xResult & $FF0000) + $00A000
    ElseIf xSingle1 >= 0.5
    xResult = (1 - xSingle1) * $2800000
    xResult = ((xResult - $14000) & $FF00) + $A00000
    ElseIf xSingle1 >= 0.25
    xResult = $A00140 - xSingle1 * $280
    ElseIf xSingle1 > 0
    xResult = xSingle1 * $2800000
    xResult = (xResult & $FF0000) + $0000A0
    Else
    xResult = $0000A0
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 405
; FirstLine = 399
; Folding = ----
; EnableUnicode
; EnableXP