EnableExplicit

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  Procedure GetOptMonitorFromPoint(x.i, y.i, *RectMonitor.RECT)
    Define.MONITORINFO xType2
  
    SystemParametersInfo_(48, 0, *RectMonitor, 0)
    x = MonitorFromPoint_((Y << 32) | (X & $ffffffff), #MONITOR_DEFAULTTONEAREST)
    If x
      xType2\cbSize = SizeOf(MONITORINFO)
      If GetMonitorInfo_(x, @xType2)
        MemCopyRTL(*RectMonitor, xType2\rcWork, SizeOf(RECT))
        EndIf
      EndIf
    EndProcedure
  CompilerElse
  Procedure GetOptMonitorFromPoint(x.i, y.i, *RectMonitor.RECT)
    Define.i xLong1
    Define.i xLong2
    Define.MONITORINFO xType2
  
    SystemParametersInfo_(48, 0, *RectMonitor, 0)
    xLong1 = GetModuleHandle_(@"user32.dll")
    If xLong1
      xLong2 = GetProcAddressAW(xLong1, "GetMonitorInfo")
      xLong1 = GetProcAddress(xLong1, "MonitorFromPoint")
      If xLong1 And xLong2
        xLong1 = CallFunctionFast(xLong1, x, y, #MONITOR_DEFAULTTONEAREST)
        If xLong1
          xType2\cbSize = SizeOf(MONITORINFO)
          If CallFunctionFast(xLong2, xLong1, @xType2)
            MemCopyRTL(*RectMonitor, xType2\rcWork, SizeOf(RECT))
            EndIf
          EndIf
        EndIf
      EndIf
    EndProcedure
  CompilerEndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 28
; FirstLine = 23
; Folding = -
; EnableUnicode
; EnableXP