EnableExplicit

Procedure.s GetSpecialFolderPathRL(hProc.i, nFolder.i)
  Define.s xResult
  Define.i xLong1

  If hProc
    If CallFunctionFast(hProc, 0, nFolder, @xLong1) = 0
      If xLong1
        If SHGetPathFromIDList_(xLong1, *ptrTemp)
          xResult = PeekS(*ptrTemp)
          EndIf
        CoTaskMemFree_(xLong1)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.s GetSpecialFolderPath(nFolder.i, SetBackSlash.i)
  Define.s xResult
  Define.i xLong1
  Define.i xLong2

  If SHGetSpecialFolderLocation_(0, nFolder, @xLong1) = 0
    If xLong1
      If SHGetPathFromIDList_(xLong1, *ptrTemp)
        xResult = PeekS(*ptrTemp)
        EndIf
      CoTaskMemFree_(xLong1)
      EndIf
    EndIf

  If Not Len(xResult)
    xLong1 = GetModuleHandle_("shfolder.dll")
    If Not xLong1
      xLong1 = LoadLibrary_("shfolder.dll")
      EndIf
    If xLong1
      xLong1 = GetProcAddress(xLong1, "SHGetSpecialFolderLocation")
      If xLong1
        If CallFunctionFast(xLong1, 0, nFolder, @xLong2) = 0
          If xLong2
            If SHGetPathFromIDList_(xLong2, *ptrTemp)
              xResult = PeekS(*ptrTemp)
              EndIf
            CoTaskMemFree_(xLong2)
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf

  xLong1 = Len(xResult)
  If xLong1
    If Right(xResult, 1) = "\"
      If Not Len(xResult)
        xResult = Left(xResult, xLong1 - 1)
        EndIf
      ElseIf SetBackSlash
      xResult = xResult + "\"
      EndIf
    EndIf

  ProcedureReturn xResult  
  EndProcedure

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 12
; FirstLine = 5
; Folding = -
; EnableUnicode
; EnableXP