﻿EnableExplicit

Structure STORAGE_HOTPLUG_INFO
  Size.l
  MediaRemovable.b
  MediaHotplug.b
  DeviceHotplug.b
  WriteCacheEnableOverride.b
  Extra.b ; size on call is 9, working so keeping!
  EndStructure

;boolean
Procedure.i IsRemoveableDriveEx(DrvRootPath.s)
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64 Or #PB_Compiler_Unicode
    Define.i xResult
    Define.i xLong1
    Define.i xLong2
    Define.STORAGE_HOTPLUG_INFO xType1

CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
    If IsMinWindows2000
CompilerEndIf
      xLong1 = CreateFile_(@DrvRootPath, 0, 3, 0, 3, 0, 0)
      If xLong1 = -1
        ProcedureReturn 0
        EndIf
      If DeviceIoControl_(xLong1, $2D0C14, 0, 0, @xType1, 9, @xLong2, 0)
        If xType1\MediaRemovable Or xType1\DeviceHotplug
          xResult = #True
          EndIf
        EndIf
      CloseHandle_(xLong1)
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
      EndIf
CompilerEndIf
    ProcedureReturn xResult
    CompilerElse
    ProcedureReturn 0
    CompilerEndIf
  EndProcedure

Procedure.i IsRemoveableDrive(DriveLetterID.i)
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64 Or #PB_Compiler_Unicode
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
    If IsMinWindows2000
CompilerEndIf
      ProcedureReturn IsRemoveableDriveEx("\\.\" + Chr(65 + DriveLetterID) + ":")
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
      EndIf
CompilerEndIf
    CompilerEndIf
  ProcedureReturn 0
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 26
; FirstLine = 11
; Folding = --
; EnableUnicode
; EnableXP