﻿EnableExplicit

LibBuild_Include(LoadResEx_WEMF_MultiOS)
LibBuild_Include(GetResDataPosEx)
LibBuild_Include(LoadIconExML)
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64 Or #PB_Compiler_Unicode
  LibBuild_Include(IconFromEMF)
  CompilerElse
  LibBuild_Include(IconFromWMF)
  CompilerEndIf

Procedure.i LoadResEx_ImageIconWEMFExML(hModule, ResID.i, SizeX.i, SizeY.i, LngID.i)
  Define.i xResult
  Define.i xDataLen

  CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
    ResID = GetResDataPosEx(hModule, ResID, @"EMF", @xDataLen, LngID)
    If ResID And xDataLen
      ResID = SetEnhMetaFileBits_(xDataLen, ResID)
      If ResID
        xResult = IconFromEMF(ResID, SizeX, SizeY)
        DeleteEnhMetaFile_(ResID)
        EndIf
      EndIf
    CompilerElse
    ResID = GetResDataPosEx(hModule, ResID, @"WMF", @xDataLen, LngID)
    If ResID And xDataLen
      ResID = SetMetaFileBitsEx_(xDataLen, ResID)
      If ResID
        xResult = IconFromWMF(ResID, SizeX, SizeY)
        DeleteMetaFile_(ResID)
        EndIf
      EndIf
    CompilerEndIf
  If Not xResult
    xResult = LoadIconExML(hModule, ResID, SizeX, SizeY, LngID)
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 31
; FirstLine = 12
; Folding = -
; EnableUnicode
; EnableXP