EnableExplicit

LibBuild_Include(SoundSchemes_ReadInt)
LibBuild_Include(BinaryBuffer_IsOK)

Procedure.i SoundSchemes_ReadApp(SchemeName.s, ApplicationName.s)
  Define.i xFail
  Define *BF

  *BF = BinaryBuffer_Create()
  If *BF
    If Not SoundSchemes_ReadInt(*BF, "\" + SchemeName, ApplicationName)
      xFail = #True
    If xFail Or Not BinaryBuffer_IsOK(*BF)
      BinaryBuffer_Discard(*BF)
      *BF = 0
      EndIf
    EndIf
  ProcedureReturn *BF
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableUnicode
; EnableXP